wxWidgets: wxRichTextCtrl Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
wxRichTextCtrl Class Reference
Class List by Category » Rich Text

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-4.x86_64/src/wxWidgets-3.1.5/interface/wx/richtext/richtextctrl.h>`

Inheritance diagram for wxRichTextCtrl:
[legend]

## Detailed Description

wxRichTextCtrl provides a generic, ground-up implementation of a text control capable of showing multiple styles and images.

wxRichTextCtrl sends notification events: see wxRichTextEvent.

It also sends the standard wxTextCtrl events `wxEVT_TEXT_ENTER` and `wxEVT_TEXT`, and wxTextUrlEvent when URL content is clicked.

For more information, see the wxRichTextCtrl Overview.

## Styles

This class supports the following styles:

- wxRE_CENTRE_CARET:
  The control will try to keep the caret line centred vertically while editing. wxRE_CENTER_CARET is a synonym for this style.
- wxRE_MULTILINE:
  The control will be multiline (mandatory).
- wxRE_READONLY:
  The control will not be editable.

  ##

Library: wxRichText

<>< =''>:</>&;&;< =''>\ </></>

Appearance:

wxMSW Appearance | wxGTK Appearance | wxOSX Appearance

## Public Member Functions
| wxRichTextCtrl ()
| Default constructor.
| wxRichTextCtrl (wxWindow *parent, wxWindowID id=-1, const wxString &value=wxEmptyString, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxRE_MULTILINE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTextCtrlNameStr)
| Constructor, creating and showing a rich text control.
virtual | ~wxRichTextCtrl ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id=-1, const wxString &value=wxEmptyString, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxRE_MULTILINE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTextCtrlNameStr)
| Creates the underlying window.
void | Init ()
| Initialises the members of the control.
virtual wxString | GetRange (long from, long to) const
| Gets the text for the given range.
virtual int | GetLineLength (long lineNo) const
| Returns the length of the specified line in characters.
virtual wxString | GetLineText (long lineNo) const
| Returns the text for the given line.
virtual int | GetNumberOfLines () const
| Returns the number of lines in the buffer.
virtual bool | IsModified () const
| Returns true if the buffer has been modified.
virtual bool | IsEditable () const
| Returns true if the control is editable.
bool | IsSingleLine () const
| Returns true if the control is single-line.
bool | IsMultiLine () const
| Returns true if the control is multiline.
virtual void | GetSelection (long *from, long *to) const
| Returns the range of the current selection.
const wxRichTextSelection & | GetSelection () const
wxRichTextSelection & | GetSelection ()
virtual wxString | GetStringSelection () const
| Returns the text within the current selection range, if any.
wxString | GetFilename () const
| Gets the current filename associated with the control.
void | SetFilename (const wxString &filename)
| Sets the current filename.
void | SetDelayedLayoutThreshold (long threshold)
| Sets the size of the buffer beyond which layout is delayed during resizing.
long | GetDelayedLayoutThreshold () const
| Gets the size of the buffer beyond which layout is delayed during resizing.
bool | GetFullLayoutRequired () const
void | SetFullLayoutRequired (bool b)
wxLongLong | GetFullLayoutTime () const
void | SetFullLayoutTime (wxLongLong t)
long | GetFullLayoutSavedPosition () const
void | SetFullLayoutSavedPosition (long p)
void | ForceDelayedLayout ()
void | SetTextCursor (const wxCursor &cursor)
| Sets the text (normal) cursor.
wxCursor | GetTextCursor () const
| Returns the text (normal) cursor.
void | SetURLCursor (const wxCursor &cursor)
| Sets the cursor to be used over URLs.
wxCursor | GetURLCursor () const
| Returns the cursor to be used over URLs.
bool | GetCaretAtLineStart () const
| Returns true if we are showing the caret position at the start of a line instead of at the end of the previous one.
void | SetCaretAtLineStart (bool atStart)
| Sets a flag to remember that we are showing the caret position at the start of a line instead of at the end of the previous one.
bool | GetDragging () const
| Returns true if we are extending a selection.
void | SetDragging (bool dragging)
| Sets a flag to remember if we are extending a selection.
bool | GetPreDrag () const
| Are we trying to start Drag'n'Drop?
void | SetPreDrag (bool pd)
| Set if we're trying to start Drag'n'Drop.
const wxPoint | GetDragStartPoint () const
| Get the possible Drag'n'Drop start point.
void | SetDragStartPoint (wxPoint sp)
| Set the possible Drag'n'Drop start point.
const wxDateTime | GetDragStartTime () const
| Get the possible Drag'n'Drop start time.
void | SetDragStartTime (wxDateTime st)
| Set the possible Drag'n'Drop start time.
wxMenu * | GetContextMenu () const
| Returns the current context menu.
void | SetContextMenu (wxMenu *menu)
| Sets the current context menu.
long | GetSelectionAnchor () const
| Returns an anchor so we know how to extend the selection.
void | SetSelectionAnchor (long anchor)
| Sets an anchor so we know how to extend the selection.
wxRichTextObject * | GetSelectionAnchorObject () const
| Returns the anchor object if selecting multiple containers.
void | SetSelectionAnchorObject (wxRichTextObject *anchor)
| Sets the anchor object if selecting multiple containers.
wxRichTextContextMenuPropertiesInfo & | GetContextMenuPropertiesInfo ()
| Returns an object that stores information about context menu property item(s), in order to communicate between the context menu event handler and the code that responds to it.
const wxRichTextContextMenuPropertiesInfo & | GetContextMenuPropertiesInfo () const
wxRichTextParagraphLayoutBox * | GetFocusObject () const
| Returns the wxRichTextObject object that currently has the editing focus.
void | StoreFocusObject (wxRichTextParagraphLayoutBox *obj)
| Setter for m_focusObject.
bool | SetFocusObject (wxRichTextParagraphLayoutBox *obj, bool setCaretPosition=true)
| Sets the wxRichTextObject object that currently has the editing focus.
void | Invalidate ()
| Invalidates the whole buffer to trigger painting later.
virtual void | Clear ()
| Clears the buffer content, leaving a single empty paragraph.
virtual void | Replace (long from, long to, const wxString &value)
| Replaces the content in the specified range with the string specified by value.
virtual void | Remove (long from, long to)
| Removes the content in the specified range.
bool | LoadFile (const wxString &file, int type=wxRICHTEXT_TYPE_ANY)
| Loads content into the control's buffer using the given type.
virtual bool | DoLoadFile (const wxString &file, int fileType)
| Helper function for LoadFile().
bool | SaveFile (const wxString &file=wxEmptyString, int type=wxRICHTEXT_TYPE_ANY)
| Saves the buffer content using the given type.
virtual bool | DoSaveFile (const wxString &file=wxEmptyString, int fileType=wxRICHTEXT_TYPE_ANY)
| Helper function for SaveFile().
void | SetHandlerFlags (int flags)
| Sets flags that change the behaviour of loading or saving.
int | GetHandlerFlags () const
| Returns flags that change the behaviour of loading or saving.
virtual void | MarkDirty ()
| Marks the buffer as modified.
virtual void | DiscardEdits ()
| Sets the buffer's modified status to false, and clears the buffer's command history.
void | SetModified (bool modified)
virtual void | SetMaxLength (unsigned long len)
| Sets the maximum number of characters that may be entered in a single line text control.
virtual void | WriteText (const wxString &text)
| Writes text at the current position.
virtual void | AppendText (const wxString &text)
| Sets the insertion point to the end of the buffer and writes the text.
virtual bool | GetStyle (long position, wxTextAttr &style)
| Gets the attributes at the given position.
virtual bool | GetStyle (long position, wxRichTextAttr &style)
virtual bool | GetStyle (long position, wxRichTextAttr &style, wxRichTextParagraphLayoutBox *container)
virtual bool | SetStyle (long start, long end, const wxTextAttr &style)
| Sets the attributes for the given range.
virtual bool | SetStyle (long start, long end, const wxRichTextAttr &style)
virtual bool | SetStyle (const wxRichTextRange &range, const wxTextAttr &style)
virtual bool | SetStyle (const wxRichTextRange &range, const wxRichTextAttr &style)
virtual void | SetStyle (wxRichTextObject *obj, const wxRichTextAttr &textAttr, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO)
| Sets the attributes for a single object.
virtual bool | GetStyleForRange (const wxRichTextRange &range, wxTextAttr &style)
| Gets the attributes common to the specified range.
virtual bool | GetStyleForRange (const wxRichTextRange &range, wxRichTextAttr &style)
virtual bool | GetStyleForRange (const wxRichTextRange &range, wxRichTextAttr &style, wxRichTextParagraphLayoutBox *container)
virtual bool | SetStyleEx (const wxRichTextRange &range, const wxRichTextAttr &style, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO)
| Sets the attributes for the given range, passing flags to determine how the attributes are set.
virtual bool | GetUncombinedStyle (long position, wxRichTextAttr &style)
| Gets the attributes at the given position.
virtual bool | GetUncombinedStyle (long position, wxRichTextAttr &style, wxRichTextParagraphLayoutBox *container)
virtual bool | SetDefaultStyle (const wxTextAttr &style)
| Sets the current default style, which can be used to change how subsequently inserted text is displayed.
virtual bool | SetDefaultStyle (const wxRichTextAttr &style)
virtual const wxRichTextAttr & | GetDefaultStyleEx () const
| Returns the current default style, which can be used to change how subsequently inserted text is displayed.
virtual bool | SetListStyle (const wxRichTextRange &range, wxRichTextListStyleDefinition *def, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom=1, int specifiedLevel=-1)
| Sets the list attributes for the given range, passing flags to determine how the attributes are set.
virtual bool | SetListStyle (const wxRichTextRange &range, const wxString &defName, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom=1, int specifiedLevel=-1)
virtual bool | ClearListStyle (const wxRichTextRange &range, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO)
| Clears the list style from the given range, clearing list-related attributes and applying any named paragraph style associated with each paragraph.
virtual bool | NumberList (const wxRichTextRange &range, wxRichTextListStyleDefinition *def=NULL, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom=1, int specifiedLevel=-1)
| Numbers the paragraphs in the given range.
virtual bool | NumberList (const wxRichTextRange &range, const wxString &defName, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom=1, int specifiedLevel=-1)
virtual bool | PromoteList (int promoteBy, const wxRichTextRange &range, wxRichTextListStyleDefinition *def=NULL, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel=-1)
| Promotes or demotes the paragraphs in the given range.
virtual bool | PromoteList (int promoteBy, const wxRichTextRange &range, const wxString &defName, int flags=wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel=-1)
virtual bool | SetProperties (const wxRichTextRange &range, const wxRichTextProperties &properties, int flags=wxRICHTEXT_SETPROPERTIES_WITH_UNDO)
| Sets the properties for the given range, passing flags to determine how the attributes are set.
virtual bool | Delete (const wxRichTextRange &range)
| Deletes the content within the given range.
virtual long | XYToPosition (long x, long y) const
| Translates from column and line number to position.
virtual bool | PositionToXY (long pos, long *x, long *y) const
| Converts a text position to zero-based column and line numbers.
virtual void | ShowPosition (long pos)
| Scrolls the buffer so that the given position is in view.
virtual wxTextCtrlHitTestResult | HitTest (const wxPoint &pt, long *pos) const
| Finds the character at the given position in pixels.
virtual wxTextCtrlHitTestResult | HitTest (const wxPoint &pt, wxTextCoord *col, wxTextCoord *row) const
wxRichTextParagraphLayoutBox * | FindContainerAtPoint (const wxPoint pt, long &position, int &hit, wxRichTextObject *hitObj, int flags=0)
| Finds the container at the given point, which is assumed to be in client coordinates.
virtual void | Copy ()
| Copies the selected content (if any) to the clipboard.
virtual void | Cut ()
| Copies the selected content (if any) to the clipboard and deletes the selection.
virtual void | Paste ()
| Pastes content from the clipboard to the buffer.
virtual void | DeleteSelection ()
| Deletes the content in the selection, if any.
virtual bool | CanCopy () const
| Returns true if selected content can be copied to the clipboard.
virtual bool | CanCut () const
| Returns true if selected content can be copied to the clipboard and deleted.
virtual bool | CanPaste () const
| Returns true if the clipboard content can be pasted to the buffer.
virtual bool | CanDeleteSelection () const
| Returns true if selected content can be deleted.
virtual void | Undo ()
| Undoes the command at the top of the command history, if there is one.
virtual void | Redo ()
| Redoes the current command.
virtual bool | CanUndo () const
| Returns true if there is a command in the command history that can be undone.
virtual bool | CanRedo () const
| Returns true if there is a command in the command history that can be redone.
virtual void | SetInsertionPoint (long pos)
| Sets the insertion point and causes the current editing style to be taken from the new position (unlike wxRichTextCtrl::SetCaretPosition).
virtual void | SetInsertionPointEnd ()
| Sets the insertion point to the end of the text control.
virtual long | GetInsertionPoint () const
| Returns the current insertion point.
virtual wxTextPos | GetLastPosition () const
| Returns the last position in the buffer.
virtual void | SetSelection (long from, long to)
| Sets the selection to the given range.
void | SetSelection (const wxRichTextSelection &sel)
virtual void | SelectAll ()
| Selects all the text in the buffer.
virtual void | SetEditable (bool editable)
| Makes the control editable, or not.
virtual bool | HasSelection () const
| Returns true if there is a selection and the object containing the selection was the same as the current focus object.
virtual bool | HasUnfocusedSelection () const
| Returns true if there was a selection, whether or not the current focus object is the same as the selection's container object.
virtual bool | WriteImage (const wxImage &image, wxBitmapType bitmapType=wxBITMAP_TYPE_PNG, const wxRichTextAttr &textAttr=wxRichTextAttr())
| Write a bitmap or image at the current insertion point.
virtual bool | WriteImage (const wxBitmap &bitmap, wxBitmapType bitmapType=wxBITMAP_TYPE_PNG, const wxRichTextAttr &textAttr=wxRichTextAttr())
virtual bool | WriteImage (const wxString &filename, wxBitmapType bitmapType, const wxRichTextAttr &textAttr=wxRichTextAttr())
| Loads an image from a file and writes it at the current insertion point.
virtual bool | WriteImage (const wxRichTextImageBlock &imageBlock, const wxRichTextAttr &textAttr=wxRichTextAttr())
| Writes an image block at the current insertion point.
virtual wxRichTextBox * | WriteTextBox (const wxRichTextAttr &textAttr=wxRichTextAttr())
| Write a text box at the current insertion point, returning the text box.
virtual wxRichTextField * | WriteField (const wxString &fieldType, const wxRichTextProperties &properties, const wxRichTextAttr &textAttr=wxRichTextAttr())
| Writes a field at the current insertion point.
virtual wxRichTextTable * | WriteTable (int rows, int cols, const wxRichTextAttr &tableAttr=wxRichTextAttr(), const wxRichTextAttr &cellAttr=wxRichTextAttr())
| Write a table at the current insertion point, returning the table.
virtual bool | Newline ()
| Inserts a new paragraph at the current insertion point.
virtual bool | LineBreak ()
| Inserts a line break at the current insertion point.
virtual void | SetBasicStyle (const wxRichTextAttr &style)
| Sets the basic (overall) style.
virtual const wxRichTextAttr & | GetBasicStyle () const
| Gets the basic (overall) style.
virtual bool | BeginStyle (const wxRichTextAttr &style)
| Begins applying a style.
virtual bool | EndStyle ()
| Ends the current style.
virtual bool | EndAllStyles ()
| Ends application of all styles in the current style stack.
bool | BeginBold ()
| Begins using bold.
bool | EndBold ()
| Ends using bold.
bool | BeginItalic ()
| Begins using italic.
bool | EndItalic ()
| Ends using italic.
bool | BeginUnderline ()
| Begins using underlining.
bool | EndUnderline ()
| End applying underlining.
bool | BeginFontSize (int pointSize)
| Begins using the given point size.
bool | EndFontSize ()
| Ends using a point size.
bool | BeginFont (const wxFont &font)
| Begins using this font.
bool | EndFont ()
| Ends using a font.
bool | BeginTextColour (const wxColour &colour)
| Begins using this colour.
bool | EndTextColour ()
| Ends applying a text colour.
bool | BeginAlignment (wxTextAttrAlignment alignment)
| Begins using alignment.
bool | EndAlignment ()
| Ends alignment.
bool | BeginLeftIndent (int leftIndent, int leftSubIndent=0)
| Begins applying a left indent and subindent in tenths of a millimetre.
bool | EndLeftIndent ()
| Ends left indent.
bool | BeginRightIndent (int rightIndent)
| Begins a right indent, specified in tenths of a millimetre.
bool | EndRightIndent ()
| Ends right indent.
bool | BeginParagraphSpacing (int before, int after)
| Begins paragraph spacing; pass the before-paragraph and after-paragraph spacing in tenths of a millimetre.
bool | EndParagraphSpacing ()
| Ends paragraph spacing.
bool | BeginLineSpacing (int lineSpacing)
| Begins applying line spacing.
bool | EndLineSpacing ()
| Ends line spacing.
bool | BeginNumberedBullet (int bulletNumber, int leftIndent, int leftSubIndent, int bulletStyle=wxTEXT_ATTR_BULLET_STYLE_ARABIC|wxTEXT_ATTR_BULLET_STYLE_PERIOD)
| Begins a numbered bullet.
bool | EndNumberedBullet ()
| Ends application of a numbered bullet.
bool | BeginSymbolBullet (const wxString &symbol, int leftIndent, int leftSubIndent, int bulletStyle=wxTEXT_ATTR_BULLET_STYLE_SYMBOL)
| Begins applying a symbol bullet, using a character from the current font.
bool | EndSymbolBullet ()
| Ends applying a symbol bullet.
bool | BeginStandardBullet (const wxString &bulletName, int leftIndent, int leftSubIndent, int bulletStyle=wxTEXT_ATTR_BULLET_STYLE_STANDARD)
| Begins applying a symbol bullet.
bool | EndStandardBullet ()
| Begins applying a standard bullet.
bool | BeginCharacterStyle (const wxString &characterStyle)
| Begins using the named character style.
bool | EndCharacterStyle ()
| Ends application of a named character style.
bool | BeginParagraphStyle (const wxString &paragraphStyle)
| Begins applying the named paragraph style.
bool | EndParagraphStyle ()
| Ends application of a named paragraph style.
bool | BeginListStyle (const wxString &listStyle, int level=1, int number=1)
| Begins using a specified list style.
bool | EndListStyle ()
| Ends using a specified list style.
bool | BeginURL (const wxString &url, const wxString &characterStyle=wxEmptyString)
| Begins applying wxTEXT_ATTR_URL to the content.
bool | EndURL ()
| Ends applying a URL.
bool | SetDefaultStyleToCursorStyle ()
| Sets the default style to the style under the cursor.
virtual void | SelectNone ()
| Cancels any selection.
virtual bool | SelectWord (long position)
| Selects the word at the given character position.
wxRichTextRange | GetSelectionRange () const
| Returns the selection range in character positions.
void | SetSelectionRange (const wxRichTextRange &range)
| Sets the selection to the given range.
wxRichTextRange | GetInternalSelectionRange () const
| Returns the selection range in character positions.
void | SetInternalSelectionRange (const wxRichTextRange &range)
| Sets the selection range in character positions.
virtual wxRichTextRange | AddParagraph (const wxString &text)
| Adds a new paragraph of text to the end of the buffer.
virtual wxRichTextRange | AddImage (const wxImage &image)
| Adds an image to the control's buffer.
virtual bool | LayoutContent (bool onlyVisibleRect=false)
| Lays out the buffer, which must be done before certain operations, such as setting the caret position.
virtual void | DoLayoutBuffer (wxRichTextBuffer &buffer, wxDC &dc, wxRichTextDrawingContext &context, const wxRect &rect, const wxRect &parentRect, int flags)
| Implements layout.
virtual bool | MoveCaret (long pos, bool showAtLineStart=false, wxRichTextParagraphLayoutBox *container=NULL)
| Move the caret to the given character position.
virtual bool | MoveRight (int noPositions=1, int flags=0)
| Moves right.
virtual bool | MoveLeft (int noPositions=1, int flags=0)
| Moves left.
virtual bool | MoveUp (int noLines=1, int flags=0)
| Moves to the start of the paragraph.
virtual bool | MoveDown (int noLines=1, int flags=0)
| Moves the caret down.
virtual bool | MoveToLineEnd (int flags=0)
| Moves to the end of the line.
virtual bool | MoveToLineStart (int flags=0)
| Moves to the start of the line.
virtual bool | MoveToParagraphEnd (int flags=0)
| Moves to the end of the paragraph.
virtual bool | MoveToParagraphStart (int flags=0)
| Moves to the start of the paragraph.
virtual bool | MoveHome (int flags=0)
| Moves to the start of the buffer.
virtual bool | MoveEnd (int flags=0)
| Moves to the end of the buffer.
virtual bool | PageUp (int noPages=1, int flags=0)
| Moves one or more pages up.
virtual bool | PageDown (int noPages=1, int flags=0)
| Moves one or more pages down.
virtual bool | WordLeft (int noPages=1, int flags=0)
| Moves a number of words to the left.
virtual bool | WordRight (int noPages=1, int flags=0)
| Move a number of words to the right.
wxRichTextBuffer & | GetBuffer ()
| Returns the buffer associated with the control.
const wxRichTextBuffer & | GetBuffer () const
virtual bool | BeginBatchUndo (const wxString &cmdName)
| Starts batching undo history for commands.
virtual bool | EndBatchUndo ()
| Ends batching undo command history.
virtual bool | BatchingUndo () const
| Returns true if undo commands are being batched.
virtual bool | BeginSuppressUndo ()
| Starts suppressing undo history for commands.
virtual bool | EndSuppressUndo ()
| Ends suppressing undo command history.
virtual bool | SuppressingUndo () const
| Returns true if undo history suppression is on.
virtual bool | HasCharacterAttributes (const wxRichTextRange &range, const wxRichTextAttr &style) const
| Test if this whole range has character attributes of the specified kind.
virtual bool | HasParagraphAttributes (const wxRichTextRange &range, const wxRichTextAttr &style) const
| Test if this whole range has paragraph attributes of the specified kind.
virtual bool | IsSelectionBold ()
| Returns true if all of the selection, or the content at the caret position, is bold.
virtual bool | IsSelectionItalics ()
| Returns true if all of the selection, or the content at the caret position, is italic.
virtual bool | IsSelectionUnderlined ()
| Returns true if all of the selection, or the content at the caret position, is underlined.
virtual bool | DoesSelectionHaveTextEffectFlag (int flag)
| Returns true if all of the selection, or the content at the current caret position, has the supplied wxTextAttrEffects flag(s).
virtual bool | IsSelectionAligned (wxTextAttrAlignment alignment)
| Returns true if all of the selection is aligned according to the specified flag.
virtual bool | ApplyBoldToSelection ()
| Apples bold to the selection or the default style (undoable).
virtual bool | ApplyItalicToSelection ()
| Applies italic to the selection or the default style (undoable).
virtual bool | ApplyUnderlineToSelection ()
| Applies underline to the selection or the default style (undoable).
virtual bool | ApplyTextEffectToSelection (int flags)
| Applies one or more wxTextAttrEffects flags to the selection (undoable).
virtual bool | ApplyAlignmentToSelection (wxTextAttrAlignment alignment)
| Applies the given alignment to the selection or the default style (undoable).
virtual bool | ApplyStyle (wxRichTextStyleDefinition *def)
| Applies the style sheet to the buffer, matching paragraph styles in the sheet against named styles in the buffer.
void | SetStyleSheet (wxRichTextStyleSheet *styleSheet)
| Sets the style sheet associated with the control.
wxRichTextStyleSheet * | GetStyleSheet () const
| Returns the style sheet associated with the control, if any.
bool | PushStyleSheet (wxRichTextStyleSheet *styleSheet)
| Push the style sheet to top of stack.
wxRichTextStyleSheet * | PopStyleSheet ()
| Pops the style sheet from top of stack.
bool | ApplyStyleSheet (wxRichTextStyleSheet *styleSheet=NULL)
| Applies the style sheet to the buffer, for example if the styles have changed.
virtual bool | ShowContextMenu (wxMenu *menu, const wxPoint &pt, bool addPropertyCommands)
| Shows the given context menu, optionally adding appropriate property-editing commands for the current position in the object hierarchy.
virtual int | PrepareContextMenu (wxMenu *menu, const wxPoint &pt, bool addPropertyCommands)
| Prepares the context menu, optionally adding appropriate property-editing commands.
virtual bool | CanEditProperties (wxRichTextObject *obj) const
| Returns true if we can edit the object's properties via a GUI.
virtual bool | EditProperties (wxRichTextObject *obj, wxWindow *parent)
| Edits the object's properties via a GUI.
virtual wxString | GetPropertiesMenuLabel (wxRichTextObject *obj)
| Gets the object's properties menu label.
virtual void | PrepareContent (wxRichTextParagraphLayoutBox &container)
| Prepares the content just before insertion (or after buffer reset).
virtual bool | CanDeleteRange (wxRichTextParagraphLayoutBox &container, const wxRichTextRange &range) const
| Can we delete this range?
virtual bool | CanInsertContent (wxRichTextParagraphLayoutBox &container, long pos) const
| Can we insert content at this position?
virtual void | EnableVerticalScrollbar (bool enable)
| Enable or disable the vertical scrollbar.
virtual bool | GetVerticalScrollbarEnabled () const
| Returns true if the vertical scrollbar is enabled.
void | SetFontScale (double fontScale, bool refresh=false)
| Sets the scale factor for displaying fonts, for example for more comfortable editing.
double | GetFontScale () const
| Returns the scale factor for displaying fonts, for example for more comfortable editing.
void | SetDimensionScale (double dimScale, bool refresh=false)
| Sets the scale factor for displaying certain dimensions such as indentation and inter-paragraph spacing.
double | GetDimensionScale () const
| Returns the scale factor for displaying certain dimensions such as indentation and inter-paragraph spacing.
void | SetScale (double scale, bool refresh=false)
| Sets an overall scale factor for displaying and editing the content.
double | GetScale () const
| Returns an overall scale factor for displaying and editing the content.
wxPoint | GetUnscaledPoint (const wxPoint &pt) const
| Returns an unscaled point.
wxPoint | GetScaledPoint (const wxPoint &pt) const
| Returns a scaled point.
wxSize | GetUnscaledSize (const wxSize &sz) const
| Returns an unscaled size.
wxSize | GetScaledSize (const wxSize &sz) const
| Returns a scaled size.
wxRect | GetUnscaledRect (const wxRect &rect) const
| Returns an unscaled rectangle.
wxRect | GetScaledRect (const wxRect &rect) const
| Returns a scaled rectangle.
bool | GetVirtualAttributesEnabled () const
| Returns true if this control can use virtual attributes and virtual text.
void | EnableVirtualAttributes (bool b)
| Pass true to let the control use virtual attributes.
void | Command (wxCommandEvent &event)
| Sends the event to the control.
void | OnDropFiles (wxDropFilesEvent &event)
| Loads the first dropped file.
void | OnCaptureLost (wxMouseCaptureLostEvent &event)
void | OnSysColourChanged (wxSysColourChangedEvent &event)
void | OnCut (wxCommandEvent &event)
| Standard handler for the wxID_CUT command.
void | OnCopy (wxCommandEvent &event)
| Standard handler for the wxID_COPY command.
void | OnPaste (wxCommandEvent &event)
| Standard handler for the wxID_PASTE command.
void | OnUndo (wxCommandEvent &event)
| Standard handler for the wxID_UNDO command.
void | OnRedo (wxCommandEvent &event)
| Standard handler for the wxID_REDO command.
void | OnSelectAll (wxCommandEvent &event)
| Standard handler for the wxID_SELECTALL command.
void | OnProperties (wxCommandEvent &event)
| Standard handler for property commands.
void | OnClear (wxCommandEvent &event)
| Standard handler for the wxID_CLEAR command.
void | OnUpdateCut (wxUpdateUIEvent &event)
| Standard update handler for the wxID_CUT command.
void | OnUpdateCopy (wxUpdateUIEvent &event)
| Standard update handler for the wxID_COPY command.
void | OnUpdatePaste (wxUpdateUIEvent &event)
| Standard update handler for the wxID_PASTE command.
void | OnUpdateUndo (wxUpdateUIEvent &event)
| Standard update handler for the wxID_UNDO command.
void | OnUpdateRedo (wxUpdateUIEvent &event)
| Standard update handler for the wxID_REDO command.
void | OnUpdateSelectAll (wxUpdateUIEvent &event)
| Standard update handler for the wxID_SELECTALL command.
void | OnUpdateProperties (wxUpdateUIEvent &event)
| Standard update handler for property commands.
void | OnUpdateClear (wxUpdateUIEvent &event)
| Standard update handler for the wxID_CLEAR command.
void | OnContextMenu (wxContextMenuEvent &event)
| Shows a standard context menu with undo, redo, cut, copy, paste, clear, and select all commands.
void | OnPaint (wxPaintEvent &event)
void | OnEraseBackground (wxEraseEvent &event)
void | OnLeftClick (wxMouseEvent &event)
void | OnLeftUp (wxMouseEvent &event)
void | OnMoveMouse (wxMouseEvent &event)
void | OnLeftDClick (wxMouseEvent &event)
void | OnMiddleClick (wxMouseEvent &event)
void | OnRightClick (wxMouseEvent &event)
void | OnChar (wxKeyEvent &event)
void | OnSize (wxSizeEvent &event)
void | OnSetFocus (wxFocusEvent &event)
void | OnKillFocus (wxFocusEvent &event)
void | OnIdle (wxIdleEvent &event)
void | OnScroll (wxScrollWinEvent &event)
virtual bool | SetFont (const wxFont &font)
| Sets the font, and also the basic and default attributes (see wxRichTextCtrl::SetDefaultStyle).
virtual void | SetupScrollbars (bool atTop=false)
| A helper function setting up scrollbars, for example after a resize.
virtual bool | KeyboardNavigate (int keyCode, int flags)
| Helper function implementing keyboard navigation.
virtual void | PaintBackground (wxDC &dc)
| Paints the background.
virtual void | PaintAboveContent (wxDC &WXUNUSED(dc))
| Other user defined painting after everything else (i.e. all text) is painted.
virtual void | DoWriteText (const wxString &value, int flags=0)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes().
virtual void | PositionCaret (wxRichTextParagraphLayoutBox *container=NULL)
| Internal function to position the visible caret according to the current caret position.
virtual bool | ExtendSelection (long oldPosition, long newPosition, int flags)
| Helper function for extending the selection, returning true if the selection was changed.
virtual bool | ExtendCellSelection (wxRichTextTable *table, int noRowSteps, int noColSteps)
| Extends a table selection in the given direction.
virtual bool | StartCellSelection (wxRichTextTable *table, wxRichTextParagraphLayoutBox *newCell)
| Starts selecting table cells.
virtual bool | ScrollIntoView (long position, int keyCode)
| Scrolls position into view.
bool | RefreshForSelectionChange (const wxRichTextSelection &oldSelection, const wxRichTextSelection &newSelection)
| Refreshes the area affected by a selection change.
void | SetCaretPosition (long position, bool showAtLineStart=false)
| Sets the caret position.
long | GetCaretPosition () const
| Returns the current caret position.
long | GetAdjustedCaretPosition (long caretPos) const
| The adjusted caret position is the character position adjusted to take into account whether we're at the start of a paragraph, in which case style information should be taken from the next position, not current one.
void | MoveCaretForward (long oldPosition)
| Move the caret one visual step forward: this may mean setting a flag and keeping the same position if we're going from the end of one line to the start of the next, which may be the exact same caret position.
void | MoveCaretBack (long oldPosition)
| Move the caret one visual step forward: this may mean setting a flag and keeping the same position if we're going from the end of one line to the start of the next, which may be the exact same caret position.
bool | GetCaretPositionForIndex (long position, wxRect &rect, wxRichTextParagraphLayoutBox *container=NULL)
| Returns the caret height and position for the given character position.
wxRichTextLine * | GetVisibleLineForCaretPosition (long caretPosition) const
| Internal helper function returning the line for the visible caret position.
wxCommandProcessor * | GetCommandProcessor () const
| Gets the command processor associated with the control's buffer.
virtual bool | DeleteSelectedContent (long *newPos=NULL)
| Deletes content if there is a selection, e.g.
wxPoint | GetPhysicalPoint (const wxPoint &ptLogical) const
| Transforms logical (unscrolled) position to physical window position.
wxPoint | GetLogicalPoint (const wxPoint &ptPhysical) const
| Transforms physical window position to logical (unscrolled) position.
virtual long | FindNextWordPosition (int direction=1) const
| Helper function for finding the caret position for the next word.
bool | IsPositionVisible (long pos) const
| Returns true if the given position is visible on the screen.
long | GetFirstVisiblePosition () const
| Returns the first visible position in the current view.
void | EnableImages (bool b)
| Enable or disable images.
bool | GetImagesEnabled () const
| Returns true if images are enabled.
void | EnableDelayedImageLoading (bool b)
| Enable or disable delayed image loading.
bool | GetDelayedImageLoading () const
| Returns true if delayed image loading is enabled.
bool | GetDelayedImageProcessingRequired () const
| Gets the flag indicating that delayed image processing is required.
void | SetDelayedImageProcessingRequired (bool b)
| Sets the flag indicating that delayed image processing is required.
wxLongLong | GetDelayedImageProcessingTime () const
| Returns the last time delayed image processing was performed.
void | SetDelayedImageProcessingTime (wxLongLong t)
| Sets the last time delayed image processing was performed.
long | GetCaretPositionForDefaultStyle () const
| Returns the caret position since the default formatting was changed.
void | SetCaretPositionForDefaultStyle (long pos)
| Set the caret position for the default style that the user is selecting.
bool | IsDefaultStyleShowing () const
| Returns true if the user has recently set the default style without moving the caret, and therefore the UI needs to reflect the default style and not the style at the caret.
void | SetAndShowDefaultStyle (const wxRichTextAttr &attr)
| Sets attr as the default style and tells the control that the UI should reflect this attribute until the user moves the caret.
wxPoint | GetFirstVisiblePoint () const
| Returns the first visible point in the window.
virtual wxString | GetValue () const
| Returns the content of the entire control as a string.
virtual void | SetValue (const wxString &value)
| Replaces existing content with the given text.
virtual bool | ProcessBackKey (wxKeyEvent &event, int flags)
| Processes the back key.
virtual wxRichTextRange | FindRangeForList (long pos, bool &isNumberedList)
| Given a character position at which there is a list style, find the range encompassing the same list style by looking backwards and forwards.
bool | SetCaretPositionAfterClick (wxRichTextParagraphLayoutBox *container, long position, int hitTestFlags, bool extendSelection=false)
| Sets up the caret for the given position and container, after a mouse click.
long | FindCaretPositionForCharacterPosition (long position, int hitTestFlags, wxRichTextParagraphLayoutBox *container, bool &caretLineStart)
| Find the caret position for the combination of hit-test flags and character position.
virtual bool | ProcessMouseMovement (wxRichTextParagraphLayoutBox *container, wxRichTextObject *obj, long position, const wxPoint &pos)
| Processes mouse movement in order to change the cursor.
virtual wxString | DoGetValue () const
bool | ProcessDelayedImageLoading (bool refresh)
| Do delayed image loading and garbage-collect other images.
bool | ProcessDelayedImageLoading (const wxRect &screenRect, wxRichTextParagraphLayoutBox *box, int &loadCount)
void | RequestDelayedImageProcessing ()
| Request delayed image processing.
void | OnTimer (wxTimerEvent &event)
| Respond to timer events.
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control.
| wxControl ()
| Default constructor to allow 2-phase creation.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel().
wxString | GetLabelText () const
| Returns the control's label without mnemonics.
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text.
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxSize | GetSizeFromText (const wxString &text) const
| Determine the minimum size needed by the control to display the given text.
void | SetLabel (const wxString &label)
| Sets the control's label.
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string.
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup.
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor.
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window.
virtual | ~wxWindow ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Construct the actual window object after creating the C++ object.
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus.
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard.
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus.
void | DisableFocusFromKeyboard ()
| Disable giving focus to this window using the keyboard navigation keys.
bool | IsFocusable () const
| Can this window itself have focus?
bool | CanAcceptFocus () const
| Can this window have focus right now?
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now?
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus.
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0).
virtual void | EnableVisibleFocus (bool enable)
| Enables or disables visible indication of keyboard focus.
virtual void | SetFocus ()
| This sets the window to receive keyboard input.
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. using `TAB` key).
virtual void | AddChild (wxWindow *child)
| Adds a child window.
bool | DestroyChildren ()
| Destroys all children of a window.
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id.
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name.
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children.
const wxWindowList & | GetChildren () const
| Returns a const reference to the list of the window's children.
virtual void | RemoveChild (wxWindow *child)
| Removes a child window.
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one.
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child.
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent.
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `NULL` if this window is the first child.
bool | IsDescendant (wxWindow *win) const
| Check if the specified window is a descendant of this one.
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g.
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling.
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position.
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range.
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size.
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation.
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation.
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown.
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up.
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up.
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly.
bool | LineUp ()
| Same as ScrollLines (-1).
bool | LineDown ()
| Same as ScrollLines (1).
bool | PageUp ()
| Same as ScrollPages (-1).
bool | PageDown ()
| Same as ScrollPages (1).
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars.
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar.
void | Center (int dir=wxBOTH)
| A synonym for Centre().
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent().
void | Centre (int direction=wxBOTH)
| Centres the window.
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent.
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object.
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object.
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...).
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates.
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position.
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels.
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units.
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates.
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates.
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour.
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all.
void | Thaw ()
| Re-enables window updating after a previous call to Freeze().
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze().
wxColour | GetBackgroundColour () const
| Returns the background colour of the window.
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window.
virtual int | GetCharHeight () const
| Returns the character height for this window.
virtual int | GetCharWidth () const
| Returns the average character width for this window.
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()).
virtual wxSize | GetDPI () const
| Return the DPI of the display used by this window.
wxFont | GetFont () const
| Returns the font for this window.
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window.
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged.
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords.
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background.
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted.
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted.
virtual void | Update ()
| Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop).
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window.
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window.
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work.
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window.
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window.
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent.
bool | UseBgCol () const
| Return true if a background colour has been set for this window.
bool | UseBackgroundColour () const
| Return true if a background colour has been set for this window.
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window.
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window.
bool | UseForegroundColour () const
| Return true if a foreground colour has been set for this window.
bool | InheritsForegroundColour () const
| Return true if this window inherits the foreground colour from its parent.
void | SetPalette (const wxPalette &pal)
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code.
virtual bool | GetThemeEnabled () const
| Returns true if the window uses the system theme for drawing its background.
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed.
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window.
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window.
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case.
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for:
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent().
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally().
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack.
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window.
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack.
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window.
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
long | GetExtraStyle () const
| Returns the extra style bits for the window.
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method.
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info.
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles.
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set.
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window.
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window.
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info.
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa.
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win.
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it.
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window.
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window.
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order).
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order).
bool | Hide ()
| Equivalent to calling wxWindow::Show(false).
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible.
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise.
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint.
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden.
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well.
bool | Disable ()
| Disables the window.
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input.
virtual bool | Show (bool show=true)
| Shows or hides the window.
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible.
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window.
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window.
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window.
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none.
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none.
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window.
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | UnsetToolTip ()
| Unset any existing tooltip.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu.
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxValidator * | GetValidator ()
| Validator functions.
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type.
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators.
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators.
virtual bool | Validate ()
| Validates the current values of the child controls using their validators.
wxWindowID | GetId () const
| Returns the identifier of the window.
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported.
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32.
virtual wxString | GetName () const
| Returns the window's name.
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant().
void | SetId (wxWindowID winid)
| Sets the identifier of the window.
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window.
virtual void | SetName (const wxString &name)
| Sets the window's name.
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use.
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window.
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any.
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window.
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window.
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window.
virtual bool | Destroy ()
| Destroys the window safely.
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed.
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL.
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window.
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles).
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL.
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL.
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer.
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| Associate the sizer with the window and set the window size and minimal size accordingly.
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none.
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints.
virtual bool | Layout ()
| Lays out the children of this window using the associated sizer.
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized.
bool | GetAutoLayout () const
| Returns true if Layout() is called automatically when the window is resized.
void | CaptureMouse ()
| Directs all mouse input to this window.
wxCaret * | GetCaret () const
| Returns the caret() associated with the window.
const wxCursor & | GetCursor () const
| Return the cursor associated with this window.
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture.
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse().
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window.
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor.
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window.
virtual bool | EnableTouchEvents (int eventsMask)
| Request generation of touch events for this window.
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Return where the given point lies, exactly.
wxHitTest | HitTest (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxBorder | GetBorder () const
| Get border for the flags of this window.
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event.
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window.
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages.
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours.
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators.
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later.
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it.
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise.
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called.
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one.
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class.
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows.
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey.
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey.
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window.
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows.
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once.
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value.
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size.
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size.
virtual void | Fit ()
| Sizes the window to fit its best size.
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window.
wxSize | FromDIP (const wxSize &sz) const
| Convert DPI-independent pixel values to the value in pixels appropriate for the current toolkit.
wxPoint | FromDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | FromDIP (int d) const
| Convert DPI-independent distance in pixels to the value in pixels appropriate for the current toolkit.
wxSize | ToDIP (const wxSize &sz) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxPoint | ToDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | ToDIP (int d) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window.
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width.
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height.
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels.
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result.
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area.
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window.
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area.
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size.
int | GetMinWidth () const
| Returns the horizontal component of window minimal size.
int | GetMinHeight () const
| Returns the vertical component of window minimal size.
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size.
int | GetMaxHeight () const
| Returns the vertical component of window maximal size.
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc.
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info.
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels.
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead.
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means).
double | GetContentScaleFactor () const
| Returns the factor mapping logical pixels of this window to physical pixels.
double | GetDPIScaleFactor () const
| Returns the ratio of the DPI used by this window to the standard DPI.
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively.
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known.
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed.
void | PostSizeEvent ()
| Posts a size event to the window.
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window.
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions.
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent().
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels.
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetContainingSizer (wxSizer *sizer)
| Used by wxSizer internally to notify the window about being managed by the given sizer.
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values.
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area.
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size.
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area.
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size.
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels.
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels.
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged.
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels.
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor.
virtual | ~wxEvtHandler ()
| Destructor.
template<typename T, typename T1, ...>
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method.
template<typename T>
void | CallAfter (const T &functor)
| Asynchronously call the given functor.
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it.
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process.
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail.
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent().
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type.
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
template<typename EventTag, typename Functor>
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
template<typename EventTag, typename Functor>
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
void * | GetClientData () const
| Returns user-supplied client data.
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object.
void | SetClientData (void *data)
| Sets user-supplied client data.
void | SetClientObject (wxClientData *data)
| Set the client data object.
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise.
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain.
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain.
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler.
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted).
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Static Public Member Functions
static const wxArrayString & | GetAvailableFontNames ()
| Font names take a long time to retrieve, so cache them (on demand).
static void | ClearAvailableFontNames ()
| Clears the cache of available font names.
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters).
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters).
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string.
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.
static wxSize | FromDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific DPI-independent pixels conversion functions.
static wxPoint | FromDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | FromDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxSize | ToDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific pixel to DPI-independent pixels conversion functions.
static wxPoint | ToDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | ToDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control.
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus.
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id.
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label.
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call).
static wxWindow * | GetCapture ()
| Returns the currently captured window.
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use.
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId().
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets.
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter().

## Protected Member Functions
virtual wxWindow * | GetEditableWindow ()
virtual bool | DoSetMargins (const wxPoint &pt)
virtual wxPoint | DoGetMargins () const
virtual wxSize | DoGetBestSize () const
| Currently this simply returns `wxSize(10, 10)`.
virtual void | DoSetValue (const wxString &value, int flags=0)
virtual void | DoThaw ()
virtual void | DoCentre (int direction)
| Centres the window.
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control.
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation.
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation.
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord).
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window.
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself.
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | QueueEvent (wxEvent *event)
| Returns the default font and colours which are used by the control.
virtual void | AddPendingEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control.
void | ProcessPendingEvents ()
| Returns the default font and colours which are used by the control.
bool | ProcessThreadEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control.
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables.
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Protected Attributes
wxRichTextBuffer | m_buffer
| Text buffer.
wxMenu * | m_contextMenu
long | m_caretPosition
| Caret position (1 less than the character position, so -1 is the first caret position).
long | m_caretPositionForDefaultStyle
| Caret position when the default formatting has been changed.
wxRichTextSelection | m_selection
| Selection range in character positions. -2, -2 means no selection.
wxRichTextCtrlSelectionState | m_selectionState
long | m_selectionAnchor
| Anchor so we know how to extend the selection It's a caret position since it's between two characters.
wxRichTextObject * | m_selectionAnchorObject
| Anchor object if selecting multiple container objects, such as grid cells.
bool | m_editable
| Are we editable?
bool | m_caretAtLineStart
| Are we showing the caret position at the start of a line instead of at the end of the previous one?
bool | m_dragging
| Are we dragging a selection?
bool | m_fullLayoutRequired
| Do we need full layout in idle?
wxLongLong | m_fullLayoutTime
long | m_fullLayoutSavedPosition
long | m_delayedLayoutThreshold
| Threshold for doing delayed layout.
wxCursor | m_textCursor
| Cursors.
wxCursor | m_urlCursor
wxRichTextContextMenuPropertiesInfo | m_contextMenuPropertiesInfo
wxRichTextParagraphLayoutBox * | m_focusObject
| The object that currently has the editing focus.
double | m_scale
| An overall scale factor.
wxSize | m_lastWindowSize
| Variables for scrollbar hysteresis detection.
int | m_setupScrollbarsCount
int | m_setupScrollbarsCountInOnSize
bool | m_enableImages
| Whether images are enabled for this control.
bool | m_enableDelayedImageLoading
| Whether delayed image loading is enabled for this control.
bool | m_delayedImageProcessingRequired
wxLongLong | m_delayedImageProcessingTime
wxTimer | m_delayedImageProcessingTimer
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Static Protected Attributes
static wxArrayString | sm_availableFontNames

## Constructor & Destructor Documentation

## ◆ wxRichTextCtrl() [1/2]

wxRichTextCtrl::wxRichTextCtrl | ( |  | ) |

Default constructor.

## ◆ wxRichTextCtrl() [2/2]

wxRichTextCtrl::wxRichTextCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id = -1,
|  | const wxString & | value = wxEmptyString,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxRE_MULTILINE,
|  | const wxValidator & | validator = wxDefaultValidator,
|  | const wxString & | name = wxTextCtrlNameStr )

Constructor, creating and showing a rich text control.

Parameters

  parent | Parent window. Must not be NULL.
  id | Window identifier. The value `wxID_ANY` indicates a default value.
  value | Default string.
  pos | Window position.
  size | Window size.
  style | Window style.
  validator | Window validator.
  name | Window name.

See also
  Create(), wxValidator

## ◆ ~wxRichTextCtrl()

virtual wxRichTextCtrl::~wxRichTextCtrl | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ AddImage()

virtual wxRichTextRange wxRichTextCtrl::AddImage | ( | const wxImage & | image | ) |
| virtual

Adds an image to the control's buffer.

## ◆ AddParagraph()

virtual wxRichTextRange wxRichTextCtrl::AddParagraph | ( | const wxString & | text | ) |
| virtual

Adds a new paragraph of text to the end of the buffer.

## ◆ AppendText()

virtual void wxRichTextCtrl::AppendText | ( | const wxString & | text | ) |
| virtual

Sets the insertion point to the end of the buffer and writes the text.

## ◆ ApplyAlignmentToSelection()

virtual bool wxRichTextCtrl::ApplyAlignmentToSelection | ( | wxTextAttrAlignment | alignment | ) |
| virtual

Applies the given alignment to the selection or the default style (undoable).

For alignment values, see wxTextAttr.

## ◆ ApplyBoldToSelection()

virtual bool wxRichTextCtrl::ApplyBoldToSelection | ( |  | ) |
| virtual

Apples bold to the selection or the default style (undoable).

## ◆ ApplyItalicToSelection()

virtual bool wxRichTextCtrl::ApplyItalicToSelection | ( |  | ) |
| virtual

Applies italic to the selection or the default style (undoable).

## ◆ ApplyStyle()

virtual bool wxRichTextCtrl::ApplyStyle | ( | wxRichTextStyleDefinition * | def | ) |
| virtual

Applies the style sheet to the buffer, matching paragraph styles in the sheet against named styles in the buffer.

This might be useful if the styles have changed. If sheet is NULL, the sheet set with SetStyleSheet() is used. Currently this applies paragraph styles only.

## ◆ ApplyStyleSheet()

bool wxRichTextCtrl::ApplyStyleSheet | ( | wxRichTextStyleSheet * | styleSheet = NULL | ) |

Applies the style sheet to the buffer, for example if the styles have changed.

## ◆ ApplyTextEffectToSelection()

virtual bool wxRichTextCtrl::ApplyTextEffectToSelection | ( | int | flags | ) |
| virtual

Applies one or more wxTextAttrEffects flags to the selection (undoable).

If there is no selection, it is applied to the default style.

## ◆ ApplyUnderlineToSelection()

virtual bool wxRichTextCtrl::ApplyUnderlineToSelection | ( |  | ) |
| virtual

Applies underline to the selection or the default style (undoable).

## ◆ BatchingUndo()

virtual bool wxRichTextCtrl::BatchingUndo | ( |  | ) | const
| virtual

Returns true if undo commands are being batched.

## ◆ BeginAlignment()

bool wxRichTextCtrl::BeginAlignment | ( | wxTextAttrAlignment | alignment | ) |

Begins using alignment.

For alignment values, see wxTextAttr.

## ◆ BeginBatchUndo()

virtual bool wxRichTextCtrl::BeginBatchUndo | ( | const wxString & | cmdName | ) |
| virtual

Starts batching undo history for commands.

## ◆ BeginBold()

bool wxRichTextCtrl::BeginBold | ( |  | ) |

Begins using bold.

## ◆ BeginCharacterStyle()

bool wxRichTextCtrl::BeginCharacterStyle | ( | const wxString & | characterStyle | ) |

Begins using the named character style.

## ◆ BeginFont()

bool wxRichTextCtrl::BeginFont | ( | const wxFont & | font | ) |

Begins using this font.

## ◆ BeginFontSize()

bool wxRichTextCtrl::BeginFontSize | ( | int | pointSize | ) |

Begins using the given point size.

## ◆ BeginItalic()

bool wxRichTextCtrl::BeginItalic | ( |  | ) |

Begins using italic.

## ◆ BeginLeftIndent()

bool wxRichTextCtrl::BeginLeftIndent | ( | int | leftIndent,
|  | int | leftSubIndent = 0 )

Begins applying a left indent and subindent in tenths of a millimetre.

The subindent is an offset from the left edge of the paragraph, and is used for all but the first line in a paragraph. A positive value will cause the first line to appear to the left of the subsequent lines, and a negative value will cause the first line to be indented to the right of the subsequent lines.

wxRichTextBuffer uses indentation to render a bulleted item. The content of the paragraph, including the first line, starts at the leftIndent plus the leftSubIndent.

Parameters

  leftIndent | The distance between the margin and the bullet.
  leftSubIndent | The distance between the left edge of the bullet and the left edge of the actual paragraph.

## ◆ BeginLineSpacing()

bool wxRichTextCtrl::BeginLineSpacing | ( | int | lineSpacing | ) |

Begins applying line spacing.

spacing is a multiple, where 10 means single-spacing, 15 means 1.5 spacing, and 20 means double spacing.

The wxTextAttrLineSpacing constants are defined for convenience.

## ◆ BeginListStyle()

bool wxRichTextCtrl::BeginListStyle | ( | const wxString & | listStyle,
|  | int | level = 1,
|  | int | number = 1 )

Begins using a specified list style.

Optionally, you can also pass a level and a number.

## ◆ BeginNumberedBullet()

bool wxRichTextCtrl::BeginNumberedBullet | ( | int | bulletNumber,
|  | int | leftIndent,
|  | int | leftSubIndent,
|  | int | bulletStyle = wxTEXT_ATTR_BULLET_STYLE_ARABIC|wxTEXT_ATTR_BULLET_STYLE_PERIOD )

Begins a numbered bullet.

This call will be needed for each item in the list, and the application should take care of incrementing the numbering.

bulletNumber is a number, usually starting with 1. leftIndent and leftSubIndent are values in tenths of a millimetre. bulletStyle is a bitlist of the wxTextAttrBulletStyle values.

wxRichTextBuffer uses indentation to render a bulleted item. The left indent is the distance between the margin and the bullet. The content of the paragraph, including the first line, starts at leftMargin + leftSubIndent. So the distance between the left edge of the bullet and the left of the actual paragraph is leftSubIndent.

## ◆ BeginParagraphSpacing()

bool wxRichTextCtrl::BeginParagraphSpacing | ( | int | before,
|  | int | after )

Begins paragraph spacing; pass the before-paragraph and after-paragraph spacing in tenths of a millimetre.

## ◆ BeginParagraphStyle()

bool wxRichTextCtrl::BeginParagraphStyle | ( | const wxString & | paragraphStyle | ) |

Begins applying the named paragraph style.

## ◆ BeginRightIndent()

bool wxRichTextCtrl::BeginRightIndent | ( | int | rightIndent | ) |

Begins a right indent, specified in tenths of a millimetre.

## ◆ BeginStandardBullet()

bool wxRichTextCtrl::BeginStandardBullet | ( | const wxString & | bulletName,
|  | int | leftIndent,
|  | int | leftSubIndent,
|  | int | bulletStyle = wxTEXT_ATTR_BULLET_STYLE_STANDARD )

Begins applying a symbol bullet.

## ◆ BeginStyle()

virtual bool wxRichTextCtrl::BeginStyle | ( | const wxRichTextAttr & | style | ) |
| virtual

Begins applying a style.

## ◆ BeginSuppressUndo()

virtual bool wxRichTextCtrl::BeginSuppressUndo | ( |  | ) |
| virtual

Starts suppressing undo history for commands.

## ◆ BeginSymbolBullet()

bool wxRichTextCtrl::BeginSymbolBullet | ( | const wxString & | symbol,
|  | int | leftIndent,
|  | int | leftSubIndent,
|  | int | bulletStyle = wxTEXT_ATTR_BULLET_STYLE_SYMBOL )

Begins applying a symbol bullet, using a character from the current font.

See BeginNumberedBullet() for an explanation of how indentation is used to render the bulleted paragraph.

## ◆ BeginTextColour()

bool wxRichTextCtrl::BeginTextColour | ( | const wxColour & | colour | ) |

Begins using this colour.

## ◆ BeginUnderline()

bool wxRichTextCtrl::BeginUnderline | ( |  | ) |

Begins using underlining.

## ◆ BeginURL()

bool wxRichTextCtrl::BeginURL | ( | const wxString & | url,
|  | const wxString & | characterStyle = wxEmptyString )

Begins applying wxTEXT_ATTR_URL to the content.

Pass a URL and optionally, a character style to apply, since it is common to mark a URL with a familiar style such as blue text with underlining.

## ◆ CanCopy()

virtual bool wxRichTextCtrl::CanCopy | ( |  | ) | const
| virtual

Returns true if selected content can be copied to the clipboard.

## ◆ CanCut()

virtual bool wxRichTextCtrl::CanCut | ( |  | ) | const
| virtual

Returns true if selected content can be copied to the clipboard and deleted.

## ◆ CanDeleteRange()

virtual bool wxRichTextCtrl::CanDeleteRange | ( | wxRichTextParagraphLayoutBox & | container,
|  | const wxRichTextRange & | range ) const
| virtual

Can we delete this range?

Sends an event to the control.

## ◆ CanDeleteSelection()

virtual bool wxRichTextCtrl::CanDeleteSelection | ( |  | ) | const
| virtual

Returns true if selected content can be deleted.

## ◆ CanEditProperties()

virtual bool wxRichTextCtrl::CanEditProperties | ( | wxRichTextObject * | obj | ) | const
| virtual

Returns true if we can edit the object's properties via a GUI.

## ◆ CanInsertContent()

virtual bool wxRichTextCtrl::CanInsertContent | ( | wxRichTextParagraphLayoutBox & | container,
|  | long | pos ) const
| virtual

Can we insert content at this position?

Sends an event to the control.

## ◆ CanPaste()

virtual bool wxRichTextCtrl::CanPaste | ( |  | ) | const
| virtual

Returns true if the clipboard content can be pasted to the buffer.

## ◆ CanRedo()

virtual bool wxRichTextCtrl::CanRedo | ( |  | ) | const
| virtual

Returns true if there is a command in the command history that can be redone.

## ◆ CanUndo()

virtual bool wxRichTextCtrl::CanUndo | ( |  | ) | const
| virtual

Returns true if there is a command in the command history that can be undone.

## ◆ Clear()

virtual void wxRichTextCtrl::Clear | ( |  | ) |
| virtual

Clears the buffer content, leaving a single empty paragraph.

Cannot be undone.

## ◆ ClearAvailableFontNames()

void wxRichTextCtrl::ClearAvailableFontNames | ( |  | ) |
| static

Clears the cache of available font names.

## ◆ ClearListStyle()

virtual bool wxRichTextCtrl::ClearListStyle | ( | const wxRichTextRange & | range,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO )
| virtual

Clears the list style from the given range, clearing list-related attributes and applying any named paragraph style associated with each paragraph.

flags is a bit list of the following:

- wxRICHTEXT_SETSTYLE_WITH_UNDO: specifies that this command will be undoable.

See also
  SetListStyle(), PromoteList(), NumberList().

## ◆ Command()

void wxRichTextCtrl::Command | ( | wxCommandEvent & | event | ) |
| virtual

Sends the event to the control.

Reimplemented from wxControl.

## ◆ Copy()

virtual void wxRichTextCtrl::Copy | ( |  | ) |
| virtual

Copies the selected content (if any) to the clipboard.

## ◆ Create()

bool wxRichTextCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = -1,
|  | const wxString & | value = wxEmptyString,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxRE_MULTILINE,
|  | const wxValidator & | validator = wxDefaultValidator,
|  | const wxString & | name = wxTextCtrlNameStr )

Creates the underlying window.

## ◆ Cut()

virtual void wxRichTextCtrl::Cut | ( |  | ) |
| virtual

Copies the selected content (if any) to the clipboard and deletes the selection.

This is undoable.

## ◆ Delete()

virtual bool wxRichTextCtrl::Delete | ( | const wxRichTextRange & | range | ) |
| virtual

Deletes the content within the given range.

## ◆ DeleteSelectedContent()

virtual bool wxRichTextCtrl::DeleteSelectedContent | ( | long * | newPos = NULL | ) |
| virtual

Deletes content if there is a selection, e.g.

when pressing a key. Returns the new caret position in newPos, or leaves it if there was no action. This is undoable.

wxPerl Note: In wxPerl this method takes no arguments and returns a 2-element list (ok, newPos).

## ◆ DeleteSelection()

virtual void wxRichTextCtrl::DeleteSelection | ( |  | ) |
| virtual

Deletes the content in the selection, if any.

This is undoable.

## ◆ DiscardEdits()

virtual void wxRichTextCtrl::DiscardEdits | ( |  | ) |
| virtual

Sets the buffer's modified status to false, and clears the buffer's command history.

## ◆ DoesSelectionHaveTextEffectFlag()

virtual bool wxRichTextCtrl::DoesSelectionHaveTextEffectFlag | ( | int | flag | ) |
| virtual

Returns true if all of the selection, or the content at the current caret position, has the supplied wxTextAttrEffects flag(s).

## ◆ DoGetBestSize()

virtual wxSize wxRichTextCtrl::DoGetBestSize | ( |  | ) | const
| protectedvirtual

Currently this simply returns `wxSize(10, 10)`.

Reimplemented from wxWindow.

## ◆ DoGetMargins()

virtual wxPoint wxRichTextCtrl::DoGetMargins | ( |  | ) | const
| protectedvirtual

## ◆ DoGetValue()

virtual wxString wxRichTextCtrl::DoGetValue | ( |  | ) | const
| virtual

## ◆ DoLayoutBuffer()

virtual void wxRichTextCtrl::DoLayoutBuffer | ( | wxRichTextBuffer & | buffer,
|  | wxDC & | dc,
|  | wxRichTextDrawingContext & | context,
|  | const wxRect & | rect,
|  | const wxRect & | parentRect,
|  | int | flags )
| virtual

Implements layout.

An application may override this to perform operations before or after layout.

## ◆ DoLoadFile()

virtual bool wxRichTextCtrl::DoLoadFile | ( | const wxString & | file,
|  | int | fileType )
| virtual

Helper function for LoadFile().

Loads content into the control's buffer using the given type.

If the specified type is wxRICHTEXT_TYPE_ANY, the type is deduced from the filename extension.

This function looks for a suitable wxRichTextFileHandler object.

## ◆ DoSaveFile()

virtual bool wxRichTextCtrl::DoSaveFile | ( | const wxString & | file = wxEmptyString,
|  | int | fileType = wxRICHTEXT_TYPE_ANY )
| virtual

Helper function for SaveFile().

Saves the buffer content using the given type.

If the specified type is wxRICHTEXT_TYPE_ANY, the type is deduced from the filename extension.

This function looks for a suitable wxRichTextFileHandler object.

## ◆ DoSetMargins()

virtual bool wxRichTextCtrl::DoSetMargins | ( | const wxPoint & | pt | ) |
| protectedvirtual

## ◆ DoSetValue()

virtual void wxRichTextCtrl::DoSetValue | ( | const wxString & | value,
|  | int | flags = 0 )
| protectedvirtual

## ◆ DoThaw()

virtual void wxRichTextCtrl::DoThaw | ( |  | ) |
| protectedvirtual

## ◆ DoWriteText()

virtual void wxRichTextCtrl::DoWriteText | ( | const wxString & | value,
|  | int | flags = 0 )
| virtual

## ◆ EditProperties()

virtual bool wxRichTextCtrl::EditProperties | ( | wxRichTextObject * | obj,
|  | wxWindow * | parent )
| virtual

Edits the object's properties via a GUI.

## ◆ EnableDelayedImageLoading()

void wxRichTextCtrl::EnableDelayedImageLoading | ( | bool | b | ) |
| inline

Enable or disable delayed image loading.

## ◆ EnableImages()

void wxRichTextCtrl::EnableImages | ( | bool | b | ) |

Enable or disable images.

## ◆ EnableVerticalScrollbar()

virtual void wxRichTextCtrl::EnableVerticalScrollbar | ( | bool | enable | ) |
| virtual

Enable or disable the vertical scrollbar.

## ◆ EnableVirtualAttributes()

void wxRichTextCtrl::EnableVirtualAttributes | ( | bool | b | ) |

Pass true to let the control use virtual attributes.

The default is false.

## ◆ EndAlignment()

bool wxRichTextCtrl::EndAlignment | ( |  | ) |

Ends alignment.

## ◆ EndAllStyles()

virtual bool wxRichTextCtrl::EndAllStyles | ( |  | ) |
| virtual

Ends application of all styles in the current style stack.

## ◆ EndBatchUndo()

virtual bool wxRichTextCtrl::EndBatchUndo | ( |  | ) |
| virtual

Ends batching undo command history.

## ◆ EndBold()

bool wxRichTextCtrl::EndBold | ( |  | ) |

Ends using bold.

## ◆ EndCharacterStyle()

bool wxRichTextCtrl::EndCharacterStyle | ( |  | ) |

Ends application of a named character style.

## ◆ EndFont()

bool wxRichTextCtrl::EndFont | ( |  | ) |

Ends using a font.

## ◆ EndFontSize()

bool wxRichTextCtrl::EndFontSize | ( |  | ) |

Ends using a point size.

## ◆ EndItalic()

bool wxRichTextCtrl::EndItalic | ( |  | ) |

Ends using italic.

## ◆ EndLeftIndent()

bool wxRichTextCtrl::EndLeftIndent | ( |  | ) |

Ends left indent.

## ◆ EndLineSpacing()

bool wxRichTextCtrl::EndLineSpacing | ( |  | ) |

Ends line spacing.

## ◆ EndListStyle()

bool wxRichTextCtrl::EndListStyle | ( |  | ) |

Ends using a specified list style.

## ◆ EndNumberedBullet()

bool wxRichTextCtrl::EndNumberedBullet | ( |  | ) |

Ends application of a numbered bullet.

## ◆ EndParagraphSpacing()

bool wxRichTextCtrl::EndParagraphSpacing | ( |  | ) |

Ends paragraph spacing.

## ◆ EndParagraphStyle()

bool wxRichTextCtrl::EndParagraphStyle | ( |  | ) |

Ends application of a named paragraph style.

## ◆ EndRightIndent()

bool wxRichTextCtrl::EndRightIndent | ( |  | ) |

Ends right indent.

## ◆ EndStandardBullet()

bool wxRichTextCtrl::EndStandardBullet | ( |  | ) |

Begins applying a standard bullet.

## ◆ EndStyle()

virtual bool wxRichTextCtrl::EndStyle | ( |  | ) |
| virtual

Ends the current style.

## ◆ EndSuppressUndo()

virtual bool wxRichTextCtrl::EndSuppressUndo | ( |  | ) |
| virtual

Ends suppressing undo command history.

## ◆ EndSymbolBullet()

bool wxRichTextCtrl::EndSymbolBullet | ( |  | ) |

Ends applying a symbol bullet.

## ◆ EndTextColour()

bool wxRichTextCtrl::EndTextColour | ( |  | ) |

Ends applying a text colour.

## ◆ EndUnderline()

bool wxRichTextCtrl::EndUnderline | ( |  | ) |

End applying underlining.

## ◆ EndURL()

bool wxRichTextCtrl::EndURL | ( |  | ) |

Ends applying a URL.

## ◆ ExtendCellSelection()

virtual bool wxRichTextCtrl::ExtendCellSelection | ( | wxRichTextTable * | table,
|  | int | noRowSteps,
|  | int | noColSteps )
| virtual

Extends a table selection in the given direction.

## ◆ ExtendSelection()

virtual bool wxRichTextCtrl::ExtendSelection | ( | long | oldPosition,
|  | long | newPosition,
|  | int | flags )
| virtual

Helper function for extending the selection, returning true if the selection was changed.

Selections are in caret positions.

## ◆ FindCaretPositionForCharacterPosition()

long wxRichTextCtrl::FindCaretPositionForCharacterPosition | ( | long | position,
|  | int | hitTestFlags,
|  | wxRichTextParagraphLayoutBox * | container,
|  | bool & | caretLineStart )

Find the caret position for the combination of hit-test flags and character position.

Returns the caret position and also an indication of where to place the caret (caretLineStart) since this is ambiguous (same position used for end of line and start of next).

## ◆ FindContainerAtPoint()

wxRichTextParagraphLayoutBox * wxRichTextCtrl::FindContainerAtPoint | ( | const wxPoint | pt,
|  | long & | position,
|  | int & | hit,
|  | wxRichTextObject * | hitObj,
|  | int | flags = 0 )

Finds the container at the given point, which is assumed to be in client coordinates.

## ◆ FindNextWordPosition()

virtual long wxRichTextCtrl::FindNextWordPosition | ( | int | direction = 1 | ) | const
| virtual

Helper function for finding the caret position for the next word.

Direction is 1 (forward) or -1 (backwards).

## ◆ FindRangeForList()

virtual wxRichTextRange wxRichTextCtrl::FindRangeForList | ( | long | pos,
|  | bool & | isNumberedList )
| virtual

Given a character position at which there is a list style, find the range encompassing the same list style by looking backwards and forwards.

## ◆ ForceDelayedLayout()

void wxRichTextCtrl::ForceDelayedLayout | ( |  | ) |

## ◆ GetAdjustedCaretPosition()

long wxRichTextCtrl::GetAdjustedCaretPosition | ( | long | caretPos | ) | const

The adjusted caret position is the character position adjusted to take into account whether we're at the start of a paragraph, in which case style information should be taken from the next position, not current one.

## ◆ GetAvailableFontNames()

const wxArrayString & wxRichTextCtrl::GetAvailableFontNames | ( |  | ) |
| static

Font names take a long time to retrieve, so cache them (on demand).

## ◆ GetBasicStyle()

virtual const wxRichTextAttr & wxRichTextCtrl::GetBasicStyle | ( |  | ) | const
| virtual

Gets the basic (overall) style.

This is the style of the whole buffer before further styles are applied, unlike the default style, which only affects the style currently being applied (for example, setting the default style to bold will cause subsequently inserted text to be bold).

## ◆ GetBuffer() [1/2]

wxRichTextBuffer & wxRichTextCtrl::GetBuffer | ( |  | ) |

Returns the buffer associated with the control.

## ◆ GetBuffer() [2/2]

const wxRichTextBuffer & wxRichTextCtrl::GetBuffer | ( |  | ) | const

## ◆ GetCaretAtLineStart()

bool wxRichTextCtrl::GetCaretAtLineStart | ( |  | ) | const

Returns true if we are showing the caret position at the start of a line instead of at the end of the previous one.

## ◆ GetCaretPosition()

long wxRichTextCtrl::GetCaretPosition | ( |  | ) | const

Returns the current caret position.

## ◆ GetCaretPositionForDefaultStyle()

long wxRichTextCtrl::GetCaretPositionForDefaultStyle | ( |  | ) | const

Returns the caret position since the default formatting was changed.

As soon as this position changes, we no longer reflect the default style in the UI. A value of -2 means that we should only reflect the style of the content under the caret.

## ◆ GetCaretPositionForIndex()

bool wxRichTextCtrl::GetCaretPositionForIndex | ( | long | position,
|  | wxRect & | rect,
|  | wxRichTextParagraphLayoutBox * | container = NULL )

Returns the caret height and position for the given character position.

If container is null, the current focus object will be used.

wxPerl Note: In wxPerl this method is implemented as GetCaretPositionForIndex(position) returning a 2-element list (ok, rect).

## ◆ GetCommandProcessor()

wxCommandProcessor * wxRichTextCtrl::GetCommandProcessor | ( |  | ) | const

Gets the command processor associated with the control's buffer.

## ◆ GetContextMenu()

wxMenu * wxRichTextCtrl::GetContextMenu | ( |  | ) | const

Returns the current context menu.

## ◆ GetContextMenuPropertiesInfo() [1/2]

wxRichTextContextMenuPropertiesInfo & wxRichTextCtrl::GetContextMenuPropertiesInfo | ( |  | ) |

Returns an object that stores information about context menu property item(s), in order to communicate between the context menu event handler and the code that responds to it.

The wxRichTextContextMenuPropertiesInfo stores one item for each object that could respond to a property-editing event. If objects are nested, several might be editable.

## ◆ GetContextMenuPropertiesInfo() [2/2]

const wxRichTextContextMenuPropertiesInfo & wxRichTextCtrl::GetContextMenuPropertiesInfo | ( |  | ) | const

## ◆ GetDefaultStyleEx()

virtual const wxRichTextAttr & wxRichTextCtrl::GetDefaultStyleEx | ( |  | ) | const
| virtual

Returns the current default style, which can be used to change how subsequently inserted text is displayed.

## ◆ GetDelayedImageLoading()

bool wxRichTextCtrl::GetDelayedImageLoading | ( |  | ) | const
| inline

Returns true if delayed image loading is enabled.

## ◆ GetDelayedImageProcessingRequired()

bool wxRichTextCtrl::GetDelayedImageProcessingRequired | ( |  | ) | const
| inline

Gets the flag indicating that delayed image processing is required.

## ◆ GetDelayedImageProcessingTime()

wxLongLong wxRichTextCtrl::GetDelayedImageProcessingTime | ( |  | ) | const
| inline

Returns the last time delayed image processing was performed.

## ◆ GetDelayedLayoutThreshold()

long wxRichTextCtrl::GetDelayedLayoutThreshold | ( |  | ) | const

Gets the size of the buffer beyond which layout is delayed during resizing.

This optimizes sizing for large buffers. The default is 20000.

## ◆ GetDimensionScale()

double wxRichTextCtrl::GetDimensionScale | ( |  | ) | const
| inline

Returns the scale factor for displaying certain dimensions such as indentation and inter-paragraph spacing.

## ◆ GetDragging()

bool wxRichTextCtrl::GetDragging | ( |  | ) | const

Returns true if we are extending a selection.

## ◆ GetDragStartPoint()

const wxPoint wxRichTextCtrl::GetDragStartPoint | ( |  | ) | const

Get the possible Drag'n'Drop start point.

## ◆ GetDragStartTime()

const wxDateTime wxRichTextCtrl::GetDragStartTime | ( |  | ) | const

Get the possible Drag'n'Drop start time.

## ◆ GetEditableWindow()

virtual wxWindow * wxRichTextCtrl::GetEditableWindow | ( |  | ) |
| protectedvirtual

## ◆ GetFilename()

wxString wxRichTextCtrl::GetFilename | ( |  | ) | const

Gets the current filename associated with the control.

## ◆ GetFirstVisiblePoint()

wxPoint wxRichTextCtrl::GetFirstVisiblePoint | ( |  | ) | const

Returns the first visible point in the window.

## ◆ GetFirstVisiblePosition()

long wxRichTextCtrl::GetFirstVisiblePosition | ( |  | ) | const

Returns the first visible position in the current view.

## ◆ GetFocusObject()

wxRichTextParagraphLayoutBox * wxRichTextCtrl::GetFocusObject | ( |  | ) | const

Returns the wxRichTextObject object that currently has the editing focus.

If there are no composite objects, this will be the top-level buffer.

## ◆ GetFontScale()

double wxRichTextCtrl::GetFontScale | ( |  | ) | const
| inline

Returns the scale factor for displaying fonts, for example for more comfortable editing.

## ◆ GetFullLayoutRequired()

bool wxRichTextCtrl::GetFullLayoutRequired | ( |  | ) | const

## ◆ GetFullLayoutSavedPosition()

long wxRichTextCtrl::GetFullLayoutSavedPosition | ( |  | ) | const

## ◆ GetFullLayoutTime()

wxLongLong wxRichTextCtrl::GetFullLayoutTime | ( |  | ) | const

## ◆ GetHandlerFlags()

int wxRichTextCtrl::GetHandlerFlags | ( |  | ) | const

Returns flags that change the behaviour of loading or saving.

See the documentation for each handler class to see what flags are relevant for each handler.

## ◆ GetImagesEnabled()

bool wxRichTextCtrl::GetImagesEnabled | ( |  | ) | const

Returns true if images are enabled.

## ◆ GetInsertionPoint()

virtual long wxRichTextCtrl::GetInsertionPoint | ( |  | ) | const
| virtual

Returns the current insertion point.

## ◆ GetInternalSelectionRange()

wxRichTextRange wxRichTextCtrl::GetInternalSelectionRange | ( |  | ) | const

Returns the selection range in character positions.

-2, -2 means no selection -1, -1 means select everything. The range is in internal format, i.e. a single character selection is denoted by (n, n)

## ◆ GetLastPosition()

virtual wxTextPos wxRichTextCtrl::GetLastPosition | ( |  | ) | const
| virtual

Returns the last position in the buffer.

## ◆ GetLineLength()

virtual int wxRichTextCtrl::GetLineLength | ( | long | lineNo | ) | const
| virtual

Returns the length of the specified line in characters.

## ◆ GetLineText()

virtual wxString wxRichTextCtrl::GetLineText | ( | long | lineNo | ) | const
| virtual

Returns the text for the given line.

## ◆ GetLogicalPoint()

wxPoint wxRichTextCtrl::GetLogicalPoint | ( | const wxPoint & | ptPhysical | ) | const

Transforms physical window position to logical (unscrolled) position.

## ◆ GetNumberOfLines()

virtual int wxRichTextCtrl::GetNumberOfLines | ( |  | ) | const
| virtual

Returns the number of lines in the buffer.

## ◆ GetPhysicalPoint()

wxPoint wxRichTextCtrl::GetPhysicalPoint | ( | const wxPoint & | ptLogical | ) | const

Transforms logical (unscrolled) position to physical window position.

## ◆ GetPreDrag()

bool wxRichTextCtrl::GetPreDrag | ( |  | ) | const

Are we trying to start Drag'n'Drop?

## ◆ GetPropertiesMenuLabel()

virtual wxString wxRichTextCtrl::GetPropertiesMenuLabel | ( | wxRichTextObject * | obj | ) |
| virtual

Gets the object's properties menu label.

## ◆ GetRange()

virtual wxString wxRichTextCtrl::GetRange | ( | long | from,
|  | long | to ) const
| virtual

Gets the text for the given range.

The end point of range is specified as the last character position of the span of text, plus one.

## ◆ GetScale()

double wxRichTextCtrl::GetScale | ( |  | ) | const

Returns an overall scale factor for displaying and editing the content.

## ◆ GetScaledPoint()

wxPoint wxRichTextCtrl::GetScaledPoint | ( | const wxPoint & | pt | ) | const

Returns a scaled point.

## ◆ GetScaledRect()

wxRect wxRichTextCtrl::GetScaledRect | ( | const wxRect & | rect | ) | const

Returns a scaled rectangle.

## ◆ GetScaledSize()

wxSize wxRichTextCtrl::GetScaledSize | ( | const wxSize & | sz | ) | const

Returns a scaled size.

## ◆ GetSelection() [1/3]

wxRichTextSelection & wxRichTextCtrl::GetSelection | ( |  | ) |

## ◆ GetSelection() [2/3]

const wxRichTextSelection & wxRichTextCtrl::GetSelection | ( |  | ) | const

## ◆ GetSelection() [3/3]

virtual void wxRichTextCtrl::GetSelection | ( | long * | from,
|  | long * | to ) const
| virtual

Returns the range of the current selection.

The end point of range is specified as the last character position of the span of text, plus one. If the return values from and to are the same, there is no selection.

## ◆ GetSelectionAnchor()

long wxRichTextCtrl::GetSelectionAnchor | ( |  | ) | const

Returns an anchor so we know how to extend the selection.

It's a caret position since it's between two characters.

## ◆ GetSelectionAnchorObject()

wxRichTextObject * wxRichTextCtrl::GetSelectionAnchorObject | ( |  | ) | const

Returns the anchor object if selecting multiple containers.

## ◆ GetSelectionRange()

wxRichTextRange wxRichTextCtrl::GetSelectionRange | ( |  | ) | const

Returns the selection range in character positions.

-1, -1 means no selection.

The range is in API convention, i.e. a single character selection is denoted by (n, n+1)

## ◆ GetStringSelection()

virtual wxString wxRichTextCtrl::GetStringSelection | ( |  | ) | const
| virtual

Returns the text within the current selection range, if any.

## ◆ GetStyle() [1/3]

virtual bool wxRichTextCtrl::GetStyle | ( | long | position,
|  | wxRichTextAttr & | style )
| virtual

## ◆ GetStyle() [2/3]

virtual bool wxRichTextCtrl::GetStyle | ( | long | position,
|  | wxRichTextAttr & | style,
|  | wxRichTextParagraphLayoutBox * | container )
| virtual

## ◆ GetStyle() [3/3]

virtual bool wxRichTextCtrl::GetStyle | ( | long | position,
|  | wxTextAttr & | style )
| virtual

Gets the attributes at the given position.

This function gets the combined style - that is, the style you see on the screen as a result of combining base style, paragraph style and character style attributes.

To get the character or paragraph style alone, use GetUncombinedStyle().

wxPerl Note: In wxPerl this method is implemented as GetStyle(position) returning a 2-element list (ok, attr).

## ◆ GetStyleForRange() [1/3]

virtual bool wxRichTextCtrl::GetStyleForRange | ( | const wxRichTextRange & | range,
|  | wxRichTextAttr & | style )
| virtual

## ◆ GetStyleForRange() [2/3]

virtual bool wxRichTextCtrl::GetStyleForRange | ( | const wxRichTextRange & | range,
|  | wxRichTextAttr & | style,
|  | wxRichTextParagraphLayoutBox * | container )
| virtual

## ◆ GetStyleForRange() [3/3]

virtual bool wxRichTextCtrl::GetStyleForRange | ( | const wxRichTextRange & | range,
|  | wxTextAttr & | style )
| virtual

Gets the attributes common to the specified range.

Attributes that differ in value within the range will not be included in style flags.

wxPerl Note: In wxPerl this method is implemented as GetStyleForRange(position) returning a 2-element list (ok, attr).

## ◆ GetStyleSheet()

wxRichTextStyleSheet * wxRichTextCtrl::GetStyleSheet | ( |  | ) | const

Returns the style sheet associated with the control, if any.

A style sheet allows named character and paragraph styles to be applied.

## ◆ GetTextCursor()

wxCursor wxRichTextCtrl::GetTextCursor | ( |  | ) | const

Returns the text (normal) cursor.

## ◆ GetUncombinedStyle() [1/2]

virtual bool wxRichTextCtrl::GetUncombinedStyle | ( | long | position,
|  | wxRichTextAttr & | style )
| virtual

Gets the attributes at the given position.

This function gets the uncombined style - that is, the attributes associated with the paragraph or character content, and not necessarily the combined attributes you see on the screen. To get the combined attributes, use GetStyle().

If you specify (any) paragraph attribute in style's flags, this function will fetch the paragraph attributes. Otherwise, it will return the character attributes.

wxPerl Note: In wxPerl this method is implemented as GetUncombinedStyle(position) returning a 2-element list (ok, attr).

## ◆ GetUncombinedStyle() [2/2]

virtual bool wxRichTextCtrl::GetUncombinedStyle | ( | long | position,
|  | wxRichTextAttr & | style,
|  | wxRichTextParagraphLayoutBox * | container )
| virtual

## ◆ GetUnscaledPoint()

wxPoint wxRichTextCtrl::GetUnscaledPoint | ( | const wxPoint & | pt | ) | const

Returns an unscaled point.

## ◆ GetUnscaledRect()

wxRect wxRichTextCtrl::GetUnscaledRect | ( | const wxRect & | rect | ) | const

Returns an unscaled rectangle.

## ◆ GetUnscaledSize()

wxSize wxRichTextCtrl::GetUnscaledSize | ( | const wxSize & | sz | ) | const

Returns an unscaled size.

## ◆ GetURLCursor()

wxCursor wxRichTextCtrl::GetURLCursor | ( |  | ) | const

Returns the cursor to be used over URLs.

## ◆ GetValue()

virtual wxString wxRichTextCtrl::GetValue | ( |  | ) | const
| virtual

Returns the content of the entire control as a string.

## ◆ GetVerticalScrollbarEnabled()

virtual bool wxRichTextCtrl::GetVerticalScrollbarEnabled | ( |  | ) | const
| virtual

Returns true if the vertical scrollbar is enabled.

## ◆ GetVirtualAttributesEnabled()

bool wxRichTextCtrl::GetVirtualAttributesEnabled | ( |  | ) | const

Returns true if this control can use virtual attributes and virtual text.

The default is false.

## ◆ GetVisibleLineForCaretPosition()

wxRichTextLine * wxRichTextCtrl::GetVisibleLineForCaretPosition | ( | long | caretPosition | ) | const

Internal helper function returning the line for the visible caret position.

If the caret is shown at the very end of the line, it means the next character is actually on the following line. So this function gets the line we're expecting to find if this is the case.

## ◆ HasCharacterAttributes()

virtual bool wxRichTextCtrl::HasCharacterAttributes | ( | const wxRichTextRange & | range,
|  | const wxRichTextAttr & | style ) const
| virtual

Test if this whole range has character attributes of the specified kind.

If any of the attributes are different within the range, the test fails.

You can use this to implement, for example, bold button updating. style must have flags indicating which attributes are of interest.

## ◆ HasParagraphAttributes()

virtual bool wxRichTextCtrl::HasParagraphAttributes | ( | const wxRichTextRange & | range,
|  | const wxRichTextAttr & | style ) const
| virtual

Test if this whole range has paragraph attributes of the specified kind.

If any of the attributes are different within the range, the test fails. You can use this to implement, for example, centering button updating. style must have flags indicating which attributes are of interest.

## ◆ HasSelection()

virtual bool wxRichTextCtrl::HasSelection | ( |  | ) | const
| virtual

Returns true if there is a selection and the object containing the selection was the same as the current focus object.

## ◆ HasUnfocusedSelection()

virtual bool wxRichTextCtrl::HasUnfocusedSelection | ( |  | ) | const
| virtual

Returns true if there was a selection, whether or not the current focus object is the same as the selection's container object.

## ◆ HitTest() [1/2]

virtual wxTextCtrlHitTestResult wxRichTextCtrl::HitTest | ( | const wxPoint & | pt,
|  | long * | pos ) const
| virtual

Finds the character at the given position in pixels.

pt is in device coords (not adjusted for the client area origin nor for scrolling).

## ◆ HitTest() [2/2]

virtual wxTextCtrlHitTestResult wxRichTextCtrl::HitTest | ( | const wxPoint & | pt,
|  | wxTextCoord * | col,
|  | wxTextCoord * | row ) const
| virtual

## ◆ Init()

void wxRichTextCtrl::Init | ( |  | ) |

Initialises the members of the control.

## ◆ Invalidate()

void wxRichTextCtrl::Invalidate | ( |  | ) |

Invalidates the whole buffer to trigger painting later.

## ◆ IsDefaultStyleShowing()

bool wxRichTextCtrl::IsDefaultStyleShowing | ( |  | ) | const

Returns true if the user has recently set the default style without moving the caret, and therefore the UI needs to reflect the default style and not the style at the caret.

Below is an example of code that uses this function to determine whether the UI should show that the current style is bold.

See also
  SetAndShowDefaultStyle().

## ◆ IsEditable()

virtual bool wxRichTextCtrl::IsEditable | ( |  | ) | const
| virtual

Returns true if the control is editable.

## ◆ IsModified()

virtual bool wxRichTextCtrl::IsModified | ( |  | ) | const
| virtual

Returns true if the buffer has been modified.

## ◆ IsMultiLine()

bool wxRichTextCtrl::IsMultiLine | ( |  | ) | const

Returns true if the control is multiline.

## ◆ IsPositionVisible()

bool wxRichTextCtrl::IsPositionVisible | ( | long | pos | ) | const

Returns true if the given position is visible on the screen.

## ◆ IsSelectionAligned()

virtual bool wxRichTextCtrl::IsSelectionAligned | ( | wxTextAttrAlignment | alignment | ) |
| virtual

Returns true if all of the selection is aligned according to the specified flag.

## ◆ IsSelectionBold()

virtual bool wxRichTextCtrl::IsSelectionBold | ( |  | ) |
| virtual

Returns true if all of the selection, or the content at the caret position, is bold.

## ◆ IsSelectionItalics()

virtual bool wxRichTextCtrl::IsSelectionItalics | ( |  | ) |
| virtual

Returns true if all of the selection, or the content at the caret position, is italic.

## ◆ IsSelectionUnderlined()

virtual bool wxRichTextCtrl::IsSelectionUnderlined | ( |  | ) |
| virtual

Returns true if all of the selection, or the content at the caret position, is underlined.

## ◆ IsSingleLine()

bool wxRichTextCtrl::IsSingleLine | ( |  | ) | const

Returns true if the control is single-line.

Currently wxRichTextCtrl does not support single-line editing.

## ◆ KeyboardNavigate()

virtual bool wxRichTextCtrl::KeyboardNavigate | ( | int | keyCode,
|  | int | flags )
| virtual

Helper function implementing keyboard navigation.

## ◆ LayoutContent()

virtual bool wxRichTextCtrl::LayoutContent | ( | bool | onlyVisibleRect = false | ) |
| virtual

Lays out the buffer, which must be done before certain operations, such as setting the caret position.

This function should not normally be required by the application.

## ◆ LineBreak()

virtual bool wxRichTextCtrl::LineBreak | ( |  | ) |
| virtual

Inserts a line break at the current insertion point.

A line break forces wrapping within a paragraph, and can be introduced by using this function, by appending the wxChar value wxRichTextLineBreakChar to text content, or by typing Shift-Return.

## ◆ LoadFile()

bool wxRichTextCtrl::LoadFile | ( | const wxString & | file,
|  | int | type = wxRICHTEXT_TYPE_ANY )

Loads content into the control's buffer using the given type.

If the specified type is wxRICHTEXT_TYPE_ANY, the type is deduced from the filename extension.

This function looks for a suitable wxRichTextFileHandler object.

## ◆ MarkDirty()

virtual void wxRichTextCtrl::MarkDirty | ( |  | ) |
| virtual

Marks the buffer as modified.

## ◆ MoveCaret()

virtual bool wxRichTextCtrl::MoveCaret | ( | long | pos,
|  | bool | showAtLineStart = false,
|  | wxRichTextParagraphLayoutBox * | container = NULL )
| virtual

Move the caret to the given character position.

Please note that this does not update the current editing style from the new position; to do that, call wxRichTextCtrl::SetInsertionPoint instead.

## ◆ MoveCaretBack()

void wxRichTextCtrl::MoveCaretBack | ( | long | oldPosition | ) |

Move the caret one visual step forward: this may mean setting a flag and keeping the same position if we're going from the end of one line to the start of the next, which may be the exact same caret position.

## ◆ MoveCaretForward()

void wxRichTextCtrl::MoveCaretForward | ( | long | oldPosition | ) |

Move the caret one visual step forward: this may mean setting a flag and keeping the same position if we're going from the end of one line to the start of the next, which may be the exact same caret position.

## ◆ MoveDown()

virtual bool wxRichTextCtrl::MoveDown | ( | int | noLines = 1,
|  | int | flags = 0 )
| virtual

Moves the caret down.

## ◆ MoveEnd()

virtual bool wxRichTextCtrl::MoveEnd | ( | int | flags = 0 | ) |
| virtual

Moves to the end of the buffer.

## ◆ MoveHome()

virtual bool wxRichTextCtrl::MoveHome | ( | int | flags = 0 | ) |
| virtual

Moves to the start of the buffer.

## ◆ MoveLeft()

virtual bool wxRichTextCtrl::MoveLeft | ( | int | noPositions = 1,
|  | int | flags = 0 )
| virtual

Moves left.

## ◆ MoveRight()

virtual bool wxRichTextCtrl::MoveRight | ( | int | noPositions = 1,
|  | int | flags = 0 )
| virtual

Moves right.

## ◆ MoveToLineEnd()

virtual bool wxRichTextCtrl::MoveToLineEnd | ( | int | flags = 0 | ) |
| virtual

Moves to the end of the line.

## ◆ MoveToLineStart()

virtual bool wxRichTextCtrl::MoveToLineStart | ( | int | flags = 0 | ) |
| virtual

Moves to the start of the line.

## ◆ MoveToParagraphEnd()

virtual bool wxRichTextCtrl::MoveToParagraphEnd | ( | int | flags = 0 | ) |
| virtual

Moves to the end of the paragraph.

## ◆ MoveToParagraphStart()

virtual bool wxRichTextCtrl::MoveToParagraphStart | ( | int | flags = 0 | ) |
| virtual

Moves to the start of the paragraph.

## ◆ MoveUp()

virtual bool wxRichTextCtrl::MoveUp | ( | int | noLines = 1,
|  | int | flags = 0 )
| virtual

Moves to the start of the paragraph.

## ◆ Newline()

virtual bool wxRichTextCtrl::Newline | ( |  | ) |
| virtual

Inserts a new paragraph at the current insertion point.

See also
  LineBreak().

## ◆ NumberList() [1/2]

virtual bool wxRichTextCtrl::NumberList | ( | const wxRichTextRange & | range,
|  | const wxString & | defName,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | startFrom = 1,
|  | int | specifiedLevel = -1 )
| virtual

## ◆ NumberList() [2/2]

virtual bool wxRichTextCtrl::NumberList | ( | const wxRichTextRange & | range,
|  | wxRichTextListStyleDefinition * | def = NULL,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | startFrom = 1,
|  | int | specifiedLevel = -1 )
| virtual

Numbers the paragraphs in the given range.

Pass flags to determine how the attributes are set.

Either the style definition or the name of the style definition (in the current sheet) can be passed.

flags is a bit list of the following:

- wxRICHTEXT_SETSTYLE_WITH_UNDO: specifies that this command will be undoable.
- wxRICHTEXT_SETSTYLE_RENUMBER: specifies that numbering should start from startFrom, otherwise existing attributes are used.
- wxRICHTEXT_SETSTYLE_SPECIFY_LEVEL: specifies that listLevel should be used as the level for all paragraphs, otherwise the current indentation will be used.

See also
  SetListStyle(), PromoteList(), ClearListStyle().

## ◆ OnCaptureLost()

void wxRichTextCtrl::OnCaptureLost | ( | wxMouseCaptureLostEvent & | event | ) |

## ◆ OnChar()

void wxRichTextCtrl::OnChar | ( | wxKeyEvent & | event | ) |

## ◆ OnClear()

void wxRichTextCtrl::OnClear | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_CLEAR command.

## ◆ OnContextMenu()

void wxRichTextCtrl::OnContextMenu | ( | wxContextMenuEvent & | event | ) |

Shows a standard context menu with undo, redo, cut, copy, paste, clear, and select all commands.

## ◆ OnCopy()

void wxRichTextCtrl::OnCopy | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_COPY command.

## ◆ OnCut()

void wxRichTextCtrl::OnCut | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_CUT command.

## ◆ OnDropFiles()

void wxRichTextCtrl::OnDropFiles | ( | wxDropFilesEvent & | event | ) |

Loads the first dropped file.

## ◆ OnEraseBackground()

void wxRichTextCtrl::OnEraseBackground | ( | wxEraseEvent & | event | ) |

## ◆ OnIdle()

void wxRichTextCtrl::OnIdle | ( | wxIdleEvent & | event | ) |

## ◆ OnKillFocus()

void wxRichTextCtrl::OnKillFocus | ( | wxFocusEvent & | event | ) |

## ◆ OnLeftClick()

void wxRichTextCtrl::OnLeftClick | ( | wxMouseEvent & | event | ) |

## ◆ OnLeftDClick()

void wxRichTextCtrl::OnLeftDClick | ( | wxMouseEvent & | event | ) |

## ◆ OnLeftUp()

void wxRichTextCtrl::OnLeftUp | ( | wxMouseEvent & | event | ) |

## ◆ OnMiddleClick()

void wxRichTextCtrl::OnMiddleClick | ( | wxMouseEvent & | event | ) |

## ◆ OnMoveMouse()

void wxRichTextCtrl::OnMoveMouse | ( | wxMouseEvent & | event | ) |

## ◆ OnPaint()

void wxRichTextCtrl::OnPaint | ( | wxPaintEvent & | event | ) |

## ◆ OnPaste()

void wxRichTextCtrl::OnPaste | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_PASTE command.

## ◆ OnProperties()

void wxRichTextCtrl::OnProperties | ( | wxCommandEvent & | event | ) |

Standard handler for property commands.

## ◆ OnRedo()

void wxRichTextCtrl::OnRedo | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_REDO command.

## ◆ OnRightClick()

void wxRichTextCtrl::OnRightClick | ( | wxMouseEvent & | event | ) |

## ◆ OnScroll()

void wxRichTextCtrl::OnScroll | ( | wxScrollWinEvent & | event | ) |

## ◆ OnSelectAll()

void wxRichTextCtrl::OnSelectAll | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_SELECTALL command.

## ◆ OnSetFocus()

void wxRichTextCtrl::OnSetFocus | ( | wxFocusEvent & | event | ) |

## ◆ OnSize()

void wxRichTextCtrl::OnSize | ( | wxSizeEvent & | event | ) |

## ◆ OnSysColourChanged()

void wxRichTextCtrl::OnSysColourChanged | ( | wxSysColourChangedEvent & | event | ) |

## ◆ OnTimer()

void wxRichTextCtrl::OnTimer | ( | wxTimerEvent & | event | ) |

Respond to timer events.

## ◆ OnUndo()

void wxRichTextCtrl::OnUndo | ( | wxCommandEvent & | event | ) |

Standard handler for the wxID_UNDO command.

## ◆ OnUpdateClear()

void wxRichTextCtrl::OnUpdateClear | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_CLEAR command.

## ◆ OnUpdateCopy()

void wxRichTextCtrl::OnUpdateCopy | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_COPY command.

## ◆ OnUpdateCut()

void wxRichTextCtrl::OnUpdateCut | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_CUT command.

## ◆ OnUpdatePaste()

void wxRichTextCtrl::OnUpdatePaste | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_PASTE command.

## ◆ OnUpdateProperties()

void wxRichTextCtrl::OnUpdateProperties | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for property commands.

## ◆ OnUpdateRedo()

void wxRichTextCtrl::OnUpdateRedo | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_REDO command.

## ◆ OnUpdateSelectAll()

void wxRichTextCtrl::OnUpdateSelectAll | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_SELECTALL command.

## ◆ OnUpdateUndo()

void wxRichTextCtrl::OnUpdateUndo | ( | wxUpdateUIEvent & | event | ) |

Standard update handler for the wxID_UNDO command.

## ◆ PageDown()

virtual bool wxRichTextCtrl::PageDown | ( | int | noPages = 1,
|  | int | flags = 0 )
| virtual

Moves one or more pages down.

## ◆ PageUp()

virtual bool wxRichTextCtrl::PageUp | ( | int | noPages = 1,
|  | int | flags = 0 )
| virtual

Moves one or more pages up.

## ◆ PaintAboveContent()

virtual void wxRichTextCtrl::PaintAboveContent | ( | wxDC & | WXUNUSEDdc | ) |
| inlinevirtual

Other user defined painting after everything else (i.e. all text) is painted.

Since
  2.9.1

## ◆ PaintBackground()

virtual void wxRichTextCtrl::PaintBackground | ( | wxDC & | dc | ) |
| virtual

Paints the background.

## ◆ Paste()

virtual void wxRichTextCtrl::Paste | ( |  | ) |
| virtual

Pastes content from the clipboard to the buffer.

## ◆ PopStyleSheet()

wxRichTextStyleSheet * wxRichTextCtrl::PopStyleSheet | ( |  | ) |

Pops the style sheet from top of stack.

## ◆ PositionCaret()

virtual void wxRichTextCtrl::PositionCaret | ( | wxRichTextParagraphLayoutBox * | container = NULL | ) |
| virtual

Internal function to position the visible caret according to the current caret position.

## ◆ PositionToXY()

virtual bool wxRichTextCtrl::PositionToXY | ( | long | pos,
|  | long * | x,
|  | long * | y ) const
| virtual

Converts a text position to zero-based column and line numbers.

## ◆ PrepareContent()

virtual void wxRichTextCtrl::PrepareContent | ( | wxRichTextParagraphLayoutBox & | container | ) |
| virtual

Prepares the content just before insertion (or after buffer reset).

Called by the same function in wxRichTextBuffer. Currently is only called if undo mode is on.

## ◆ PrepareContextMenu()

virtual int wxRichTextCtrl::PrepareContextMenu | ( | wxMenu * | menu,
|  | const wxPoint & | pt,
|  | bool | addPropertyCommands )
| virtual

Prepares the context menu, optionally adding appropriate property-editing commands.

Returns the number of property commands added.

## ◆ ProcessBackKey()

virtual bool wxRichTextCtrl::ProcessBackKey | ( | wxKeyEvent & | event,
|  | int | flags )
| virtual

Processes the back key.

## ◆ ProcessDelayedImageLoading() [1/2]

bool wxRichTextCtrl::ProcessDelayedImageLoading | ( | bool | refresh | ) |

Do delayed image loading and garbage-collect other images.

## ◆ ProcessDelayedImageLoading() [2/2]

bool wxRichTextCtrl::ProcessDelayedImageLoading | ( | const wxRect & | screenRect,
|  | wxRichTextParagraphLayoutBox * | box,
|  | int & | loadCount )

## ◆ ProcessMouseMovement()

virtual bool wxRichTextCtrl::ProcessMouseMovement | ( | wxRichTextParagraphLayoutBox * | container,
|  | wxRichTextObject * | obj,
|  | long | position,
|  | const wxPoint & | pos )
| virtual

Processes mouse movement in order to change the cursor.

## ◆ PromoteList() [1/2]

virtual bool wxRichTextCtrl::PromoteList | ( | int | promoteBy,
|  | const wxRichTextRange & | range,
|  | const wxString & | defName,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | specifiedLevel = -1 )
| virtual

## ◆ PromoteList() [2/2]

virtual bool wxRichTextCtrl::PromoteList | ( | int | promoteBy,
|  | const wxRichTextRange & | range,
|  | wxRichTextListStyleDefinition * | def = NULL,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | specifiedLevel = -1 )
| virtual

Promotes or demotes the paragraphs in the given range.

A positive promoteBy produces a smaller indent, and a negative number produces a larger indent. Pass flags to determine how the attributes are set. Either the style definition or the name of the style definition (in the current sheet) can be passed.

flags is a bit list of the following:

- wxRICHTEXT_SETSTYLE_WITH_UNDO: specifies that this command will be undoable.
- wxRICHTEXT_SETSTYLE_RENUMBER: specifies that numbering should start from startFrom, otherwise existing attributes are used.
- wxRICHTEXT_SETSTYLE_SPECIFY_LEVEL: specifies that listLevel should be used as the level for all paragraphs, otherwise the current indentation will be used.

See also
  SetListStyle(),
  SetListStyle(), ClearListStyle().

## ◆ PushStyleSheet()

bool wxRichTextCtrl::PushStyleSheet | ( | wxRichTextStyleSheet * | styleSheet | ) |

Push the style sheet to top of stack.

## ◆ Redo()

virtual void wxRichTextCtrl::Redo | ( |  | ) |
| virtual

Redoes the current command.

## ◆ RefreshForSelectionChange()

bool wxRichTextCtrl::RefreshForSelectionChange | ( | const wxRichTextSelection & | oldSelection,
|  | const wxRichTextSelection & | newSelection )

Refreshes the area affected by a selection change.

## ◆ Remove()

virtual void wxRichTextCtrl::Remove | ( | long | from,
|  | long | to )
| virtual

Removes the content in the specified range.

## ◆ Replace()

virtual void wxRichTextCtrl::Replace | ( | long | from,
|  | long | to,
|  | const wxString & | value )
| virtual

Replaces the content in the specified range with the string specified by value.

## ◆ RequestDelayedImageProcessing()

void wxRichTextCtrl::RequestDelayedImageProcessing | ( |  | ) |

Request delayed image processing.

## ◆ SaveFile()

bool wxRichTextCtrl::SaveFile | ( | const wxString & | file = wxEmptyString,
|  | int | type = wxRICHTEXT_TYPE_ANY )

Saves the buffer content using the given type.

If the specified type is wxRICHTEXT_TYPE_ANY, the type is deduced from the filename extension.

This function looks for a suitable wxRichTextFileHandler object.

## ◆ ScrollIntoView()

virtual bool wxRichTextCtrl::ScrollIntoView | ( | long | position,
|  | int | keyCode )
| virtual

Scrolls position into view.

This function takes a caret position.

## ◆ SelectAll()

virtual void wxRichTextCtrl::SelectAll | ( |  | ) |
| virtual

Selects all the text in the buffer.

## ◆ SelectNone()

virtual void wxRichTextCtrl::SelectNone | ( |  | ) |
| virtual

Cancels any selection.

## ◆ SelectWord()

virtual bool wxRichTextCtrl::SelectWord | ( | long | position | ) |
| virtual

Selects the word at the given character position.

## ◆ SetAndShowDefaultStyle()

void wxRichTextCtrl::SetAndShowDefaultStyle | ( | const wxRichTextAttr & | attr | ) |

Sets attr as the default style and tells the control that the UI should reflect this attribute until the user moves the caret.

See also
  IsDefaultStyleShowing().

## ◆ SetBasicStyle()

virtual void wxRichTextCtrl::SetBasicStyle | ( | const wxRichTextAttr & | style | ) |
| virtual

Sets the basic (overall) style.

This is the style of the whole buffer before further styles are applied, unlike the default style, which only affects the style currently being applied (for example, setting the default style to bold will cause subsequently inserted text to be bold).

## ◆ SetCaretAtLineStart()

void wxRichTextCtrl::SetCaretAtLineStart | ( | bool | atStart | ) |

Sets a flag to remember that we are showing the caret position at the start of a line instead of at the end of the previous one.

## ◆ SetCaretPosition()

void wxRichTextCtrl::SetCaretPosition | ( | long | position,
|  | bool | showAtLineStart = false )

Sets the caret position.

The caret position is the character position just before the caret. A value of -1 means the caret is at the start of the buffer. Please note that this does not update the current editing style from the new position or cause the actual caret to be refreshed; to do that, call wxRichTextCtrl::SetInsertionPoint instead.

## ◆ SetCaretPositionAfterClick()

bool wxRichTextCtrl::SetCaretPositionAfterClick | ( | wxRichTextParagraphLayoutBox * | container,
|  | long | position,
|  | int | hitTestFlags,
|  | bool | extendSelection = false )

Sets up the caret for the given position and container, after a mouse click.

## ◆ SetCaretPositionForDefaultStyle()

void wxRichTextCtrl::SetCaretPositionForDefaultStyle | ( | long | pos | ) |

Set the caret position for the default style that the user is selecting.

## ◆ SetContextMenu()

void wxRichTextCtrl::SetContextMenu | ( | wxMenu * | menu | ) |

Sets the current context menu.

## ◆ SetDefaultStyle() [1/2]

virtual bool wxRichTextCtrl::SetDefaultStyle | ( | const wxRichTextAttr & | style | ) |
| virtual

## ◆ SetDefaultStyle() [2/2]

virtual bool wxRichTextCtrl::SetDefaultStyle | ( | const wxTextAttr & | style | ) |
| virtual

Sets the current default style, which can be used to change how subsequently inserted text is displayed.

## ◆ SetDefaultStyleToCursorStyle()

bool wxRichTextCtrl::SetDefaultStyleToCursorStyle | ( |  | ) |

Sets the default style to the style under the cursor.

## ◆ SetDelayedImageProcessingRequired()

void wxRichTextCtrl::SetDelayedImageProcessingRequired | ( | bool | b | ) |
| inline

Sets the flag indicating that delayed image processing is required.

## ◆ SetDelayedImageProcessingTime()

void wxRichTextCtrl::SetDelayedImageProcessingTime | ( | wxLongLong | t | ) |
| inline

Sets the last time delayed image processing was performed.

## ◆ SetDelayedLayoutThreshold()

void wxRichTextCtrl::SetDelayedLayoutThreshold | ( | long | threshold | ) |

Sets the size of the buffer beyond which layout is delayed during resizing.

This optimizes sizing for large buffers. The default is 20000.

## ◆ SetDimensionScale()

void wxRichTextCtrl::SetDimensionScale | ( | double | dimScale,
|  | bool | refresh = false )

Sets the scale factor for displaying certain dimensions such as indentation and inter-paragraph spacing.

This can be useful when editing in a small control where you still want legible text, but a minimum of wasted white space.

## ◆ SetDragging()

void wxRichTextCtrl::SetDragging | ( | bool | dragging | ) |

Sets a flag to remember if we are extending a selection.

## ◆ SetDragStartPoint()

void wxRichTextCtrl::SetDragStartPoint | ( | wxPoint | sp | ) |

Set the possible Drag'n'Drop start point.

## ◆ SetDragStartTime()

void wxRichTextCtrl::SetDragStartTime | ( | wxDateTime | st | ) |

Set the possible Drag'n'Drop start time.

## ◆ SetEditable()

virtual void wxRichTextCtrl::SetEditable | ( | bool | editable | ) |
| virtual

Makes the control editable, or not.

## ◆ SetFilename()

void wxRichTextCtrl::SetFilename | ( | const wxString & | filename | ) |

Sets the current filename.

## ◆ SetFocusObject()

bool wxRichTextCtrl::SetFocusObject | ( | wxRichTextParagraphLayoutBox * | obj,
|  | bool | setCaretPosition = true )

Sets the wxRichTextObject object that currently has the editing focus.

Parameters

  obj | The wxRichTextObject to set focus on.
  setCaretPosition | Optionally set the caret position.

## ◆ SetFont()

virtual bool wxRichTextCtrl::SetFont | ( | const wxFont & | font | ) |
| virtual

Sets the font, and also the basic and default attributes (see wxRichTextCtrl::SetDefaultStyle).

Reimplemented from wxWindow.

## ◆ SetFontScale()

void wxRichTextCtrl::SetFontScale | ( | double | fontScale,
|  | bool | refresh = false )

Sets the scale factor for displaying fonts, for example for more comfortable editing.

## ◆ SetFullLayoutRequired()

void wxRichTextCtrl::SetFullLayoutRequired | ( | bool | b | ) |

## ◆ SetFullLayoutSavedPosition()

void wxRichTextCtrl::SetFullLayoutSavedPosition | ( | long | p | ) |

## ◆ SetFullLayoutTime()

void wxRichTextCtrl::SetFullLayoutTime | ( | wxLongLong | t | ) |

## ◆ SetHandlerFlags()

void wxRichTextCtrl::SetHandlerFlags | ( | int | flags | ) |

Sets flags that change the behaviour of loading or saving.

See the documentation for each handler class to see what flags are relevant for each handler.

## ◆ SetInsertionPoint()

virtual void wxRichTextCtrl::SetInsertionPoint | ( | long | pos | ) |
| virtual

Sets the insertion point and causes the current editing style to be taken from the new position (unlike wxRichTextCtrl::SetCaretPosition).

## ◆ SetInsertionPointEnd()

virtual void wxRichTextCtrl::SetInsertionPointEnd | ( |  | ) |
| virtual

Sets the insertion point to the end of the text control.

## ◆ SetInternalSelectionRange()

void wxRichTextCtrl::SetInternalSelectionRange | ( | const wxRichTextRange & | range | ) |

Sets the selection range in character positions.

-2, -2 means no selection -1, -1 means select everything. The range is in internal format, i.e. a single character selection is denoted by (n, n)

## ◆ SetListStyle() [1/2]

virtual bool wxRichTextCtrl::SetListStyle | ( | const wxRichTextRange & | range,
|  | const wxString & | defName,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | startFrom = 1,
|  | int | specifiedLevel = -1 )
| virtual

## ◆ SetListStyle() [2/2]

virtual bool wxRichTextCtrl::SetListStyle | ( | const wxRichTextRange & | range,
|  | wxRichTextListStyleDefinition * | def,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO,
|  | int | startFrom = 1,
|  | int | specifiedLevel = -1 )
| virtual

Sets the list attributes for the given range, passing flags to determine how the attributes are set.

Either the style definition or the name of the style definition (in the current sheet) can be passed. flags is a bit list of the following:

- wxRICHTEXT_SETSTYLE_WITH_UNDO: specifies that this command will be undoable.
- wxRICHTEXT_SETSTYLE_RENUMBER: specifies that numbering should start from startFrom, otherwise existing attributes are used.
- wxRICHTEXT_SETSTYLE_SPECIFY_LEVEL: specifies that listLevel should be used as the level for all paragraphs, otherwise the current indentation will be used.

See also
  NumberList(), PromoteList(), ClearListStyle().

## ◆ SetMaxLength()

virtual void wxRichTextCtrl::SetMaxLength | ( | unsigned long | len | ) |
| virtual

Sets the maximum number of characters that may be entered in a single line text control.

For compatibility only; currently does nothing.

## ◆ SetModified()

void wxRichTextCtrl::SetModified | ( | bool | modified | ) |

## ◆ SetPreDrag()

void wxRichTextCtrl::SetPreDrag | ( | bool | pd | ) |

Set if we're trying to start Drag'n'Drop.

## ◆ SetProperties()

virtual bool wxRichTextCtrl::SetProperties | ( | const wxRichTextRange & | range,
|  | const wxRichTextProperties & | properties,
|  | int | flags = wxRICHTEXT_SETPROPERTIES_WITH_UNDO )
| virtual

Sets the properties for the given range, passing flags to determine how the attributes are set.

You can merge properties or replace them.

The end point of range is specified as the last character position of the span of text, plus one. So, for example, to set the properties for a character at position 5, use the range (5,6).

flags may contain a bit list of the following values:

- wxRICHTEXT_SETSPROPERTIES_NONE: no flag.
- wxRICHTEXT_SETPROPERTIES_WITH_UNDO: specifies that this operation should be undoable.
- wxRICHTEXT_SETPROPERTIES_PARAGRAPHS_ONLY: specifies that the properties should only be applied to paragraphs, and not the content.
- wxRICHTEXT_SETPROPERTIES_CHARACTERS_ONLY: specifies that the properties should only be applied to characters, and not the paragraph.
- wxRICHTEXT_SETPROPERTIES_RESET: resets (clears) the existing properties before applying the new properties.
- wxRICHTEXT_SETPROPERTIES_REMOVE: removes the specified properties.

## ◆ SetScale()

void wxRichTextCtrl::SetScale | ( | double | scale,
|  | bool | refresh = false )

Sets an overall scale factor for displaying and editing the content.

## ◆ SetSelection() [1/2]

void wxRichTextCtrl::SetSelection | ( | const wxRichTextSelection & | sel | ) |

## ◆ SetSelection() [2/2]

virtual void wxRichTextCtrl::SetSelection | ( | long | from,
|  | long | to )
| virtual

Sets the selection to the given range.

The end point of range is specified as the last character position of the span of text, plus one.

So, for example, to set the selection for a character at position 5, use the range (5,6).

## ◆ SetSelectionAnchor()

void wxRichTextCtrl::SetSelectionAnchor | ( | long | anchor | ) |

Sets an anchor so we know how to extend the selection.

It's a caret position since it's between two characters.

## ◆ SetSelectionAnchorObject()

void wxRichTextCtrl::SetSelectionAnchorObject | ( | wxRichTextObject * | anchor | ) |

Sets the anchor object if selecting multiple containers.

## ◆ SetSelectionRange()

void wxRichTextCtrl::SetSelectionRange | ( | const wxRichTextRange & | range | ) |

Sets the selection to the given range.

The end point of range is specified as the last character position of the span of text, plus one.

So, for example, to set the selection for a character at position 5, use the range (5,6).

## ◆ SetStyle() [1/5]

virtual bool wxRichTextCtrl::SetStyle | ( | const wxRichTextRange & | range,
|  | const wxRichTextAttr & | style )
| virtual

## ◆ SetStyle() [2/5]

virtual bool wxRichTextCtrl::SetStyle | ( | const wxRichTextRange & | range,
|  | const wxTextAttr & | style )
| virtual

## ◆ SetStyle() [3/5]

virtual bool wxRichTextCtrl::SetStyle | ( | long | start,
|  | long | end,
|  | const wxRichTextAttr & | style )
| virtual

## ◆ SetStyle() [4/5]

virtual bool wxRichTextCtrl::SetStyle | ( | long | start,
|  | long | end,
|  | const wxTextAttr & | style )
| virtual

Sets the attributes for the given range.

The end point of range is specified as the last character position of the span of text, plus one.

So, for example, to set the style for a character at position 5, use the range (5,6).

## ◆ SetStyle() [5/5]

virtual void wxRichTextCtrl::SetStyle | ( | wxRichTextObject * | obj,
|  | const wxRichTextAttr & | textAttr,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO )
| virtual

Sets the attributes for a single object.

## ◆ SetStyleEx()

virtual bool wxRichTextCtrl::SetStyleEx | ( | const wxRichTextRange & | range,
|  | const wxRichTextAttr & | style,
|  | int | flags = wxRICHTEXT_SETSTYLE_WITH_UNDO )
| virtual

Sets the attributes for the given range, passing flags to determine how the attributes are set.

The end point of range is specified as the last character position of the span of text, plus one. So, for example, to set the style for a character at position 5, use the range (5,6).

flags may contain a bit list of the following values:

- wxRICHTEXT_SETSTYLE_NONE: no style flag.
- wxRICHTEXT_SETSTYLE_WITH_UNDO: specifies that this operation should be undoable.
- wxRICHTEXT_SETSTYLE_OPTIMIZE: specifies that the style should not be applied if the combined style at this point is already the style in question.
- wxRICHTEXT_SETSTYLE_PARAGRAPHS_ONLY: specifies that the style should only be applied to paragraphs, and not the content. This allows content styling to be preserved independently from that of e.g. a named paragraph style.
- wxRICHTEXT_SETSTYLE_CHARACTERS_ONLY: specifies that the style should only be applied to characters, and not the paragraph. This allows content styling to be preserved independently from that of e.g. a named paragraph style.
- wxRICHTEXT_SETSTYLE_RESET: resets (clears) the existing style before applying the new style.
- wxRICHTEXT_SETSTYLE_REMOVE: removes the specified style. Only the style flags are used in this operation.

## ◆ SetStyleSheet()

void wxRichTextCtrl::SetStyleSheet | ( | wxRichTextStyleSheet * | styleSheet | ) |

Sets the style sheet associated with the control.

A style sheet allows named character and paragraph styles to be applied.

## ◆ SetTextCursor()

void wxRichTextCtrl::SetTextCursor | ( | const wxCursor & | cursor | ) |

Sets the text (normal) cursor.

## ◆ SetupScrollbars()

virtual void wxRichTextCtrl::SetupScrollbars | ( | bool | atTop = false | ) |
| virtual

A helper function setting up scrollbars, for example after a resize.

## ◆ SetURLCursor()

void wxRichTextCtrl::SetURLCursor | ( | const wxCursor & | cursor | ) |

Sets the cursor to be used over URLs.

## ◆ SetValue()

virtual void wxRichTextCtrl::SetValue | ( | const wxString & | value | ) |
| virtual

Replaces existing content with the given text.

## ◆ ShouldInheritColours()

virtual bool wxRichTextCtrl::ShouldInheritColours | ( |  | ) | const
| virtual

Return true from here to allow the colours of this window to be changed by InheritAttributes().

Returning false forbids inheriting them from the parent window.

The base class version returns false, but this method is overridden in wxControl where it returns true.

Reimplemented from wxWindow.

## ◆ ShowContextMenu()

virtual bool wxRichTextCtrl::ShowContextMenu | ( | wxMenu * | menu,
|  | const wxPoint & | pt,
|  | bool | addPropertyCommands )
| virtual

Shows the given context menu, optionally adding appropriate property-editing commands for the current position in the object hierarchy.

## ◆ ShowPosition()

virtual void wxRichTextCtrl::ShowPosition | ( | long | pos | ) |
| virtual

Scrolls the buffer so that the given position is in view.

## ◆ StartCellSelection()

virtual bool wxRichTextCtrl::StartCellSelection | ( | wxRichTextTable * | table,
|  | wxRichTextParagraphLayoutBox * | newCell )
| virtual

Starts selecting table cells.

## ◆ StoreFocusObject()

void wxRichTextCtrl::StoreFocusObject | ( | wxRichTextParagraphLayoutBox * | obj | ) |

Setter for m_focusObject.

## ◆ SuppressingUndo()

virtual bool wxRichTextCtrl::SuppressingUndo | ( |  | ) | const
| virtual

Returns true if undo history suppression is on.

## ◆ Undo()

virtual void wxRichTextCtrl::Undo | ( |  | ) |
| virtual

Undoes the command at the top of the command history, if there is one.

## ◆ WordLeft()

virtual bool wxRichTextCtrl::WordLeft | ( | int | noPages = 1,
|  | int | flags = 0 )
| virtual

Moves a number of words to the left.

## ◆ WordRight()

virtual bool wxRichTextCtrl::WordRight | ( | int | noPages = 1,
|  | int | flags = 0 )
| virtual

Move a number of words to the right.

## ◆ WriteField()

virtual wxRichTextField * wxRichTextCtrl::WriteField | ( | const wxString & | fieldType,
|  | const wxRichTextProperties & | properties,
|  | const wxRichTextAttr & | textAttr = wxRichTextAttr() )
| virtual

Writes a field at the current insertion point.

Parameters

  fieldType | The field type, matching an existing field type definition.
  properties | Extra data for the field.
  textAttr | Optional attributes.

See also
  wxRichTextField, wxRichTextFieldType, wxRichTextFieldTypeStandard

## ◆ WriteImage() [1/4]

virtual bool wxRichTextCtrl::WriteImage | ( | const wxBitmap & | bitmap,
|  | wxBitmapType | bitmapType = wxBITMAP_TYPE_PNG,
|  | const wxRichTextAttr & | textAttr = wxRichTextAttr() )
| virtual

## ◆ WriteImage() [2/4]

virtual bool wxRichTextCtrl::WriteImage | ( | const wxImage & | image,
|  | wxBitmapType | bitmapType = wxBITMAP_TYPE_PNG,
|  | const wxRichTextAttr & | textAttr = wxRichTextAttr() )
| virtual

Write a bitmap or image at the current insertion point.

Supply an optional type to use for internal and file storage of the raw data.

## ◆ WriteImage() [3/4]

virtual bool wxRichTextCtrl::WriteImage | ( | const wxRichTextImageBlock & | imageBlock,
|  | const wxRichTextAttr & | textAttr = wxRichTextAttr() )
| virtual

Writes an image block at the current insertion point.

## ◆ WriteImage() [4/4]

virtual bool wxRichTextCtrl::WriteImage | ( | const wxString & | filename,
|  | wxBitmapType | bitmapType,
|  | const wxRichTextAttr & | textAttr = wxRichTextAttr() )
| virtual

Loads an image from a file and writes it at the current insertion point.

## ◆ WriteTable()

virtual wxRichTextTable * wxRichTextCtrl::WriteTable | ( | int | rows,
|  | int | cols,
|  | const wxRichTextAttr & | tableAttr = wxRichTextAttr(),
|  | const wxRichTextAttr & | cellAttr = wxRichTextAttr() )
| virtual

Write a table at the current insertion point, returning the table.

You can then call SetFocusObject() to set the focus to the new object.

## ◆ WriteText()

virtual void wxRichTextCtrl::WriteText | ( | const wxString & | text | ) |
| virtual

Writes text at the current position.

## ◆ WriteTextBox()

virtual wxRichTextBox * wxRichTextCtrl::WriteTextBox | ( | const wxRichTextAttr & | textAttr = wxRichTextAttr() | ) |
| virtual

Write a text box at the current insertion point, returning the text box.

You can then call SetFocusObject() to set the focus to the new object.

## ◆ XYToPosition()

virtual long wxRichTextCtrl::XYToPosition | ( | long | x,
|  | long | y ) const
| virtual

Translates from column and line number to position.

## Member Data Documentation

## ◆ m_buffer

wxRichTextBuffer wxRichTextCtrl::m_buffer
| protected

Text buffer.

## ◆ m_caretAtLineStart

bool wxRichTextCtrl::m_caretAtLineStart
| protected

Are we showing the caret position at the start of a line instead of at the end of the previous one?

## ◆ m_caretPosition

long wxRichTextCtrl::m_caretPosition
| protected

Caret position (1 less than the character position, so -1 is the first caret position).

## ◆ m_caretPositionForDefaultStyle

long wxRichTextCtrl::m_caretPositionForDefaultStyle
| protected

Caret position when the default formatting has been changed.

As soon as this position changes, we no longer reflect the default style in the UI.

## ◆ m_contextMenu

wxMenu* wxRichTextCtrl::m_contextMenu
| protected

## ◆ m_contextMenuPropertiesInfo

wxRichTextContextMenuPropertiesInfo wxRichTextCtrl::m_contextMenuPropertiesInfo
| protected

## ◆ m_delayedImageProcessingRequired

bool wxRichTextCtrl::m_delayedImageProcessingRequired
| protected

## ◆ m_delayedImageProcessingTime

wxLongLong wxRichTextCtrl::m_delayedImageProcessingTime
| protected

## ◆ m_delayedImageProcessingTimer

wxTimer wxRichTextCtrl::m_delayedImageProcessingTimer
| protected

## ◆ m_delayedLayoutThreshold

long wxRichTextCtrl::m_delayedLayoutThreshold
| protected

Threshold for doing delayed layout.

## ◆ m_dragging

bool wxRichTextCtrl::m_dragging
| protected

Are we dragging a selection?

## ◆ m_editable

bool wxRichTextCtrl::m_editable
| protected

Are we editable?

## ◆ m_enableDelayedImageLoading

bool wxRichTextCtrl::m_enableDelayedImageLoading
| protected

Whether delayed image loading is enabled for this control.

## ◆ m_enableImages

bool wxRichTextCtrl::m_enableImages
| protected

Whether images are enabled for this control.

## ◆ m_focusObject

wxRichTextParagraphLayoutBox* wxRichTextCtrl::m_focusObject
| protected

The object that currently has the editing focus.

## ◆ m_fullLayoutRequired

bool wxRichTextCtrl::m_fullLayoutRequired
| protected

Do we need full layout in idle?

## ◆ m_fullLayoutSavedPosition

long wxRichTextCtrl::m_fullLayoutSavedPosition
| protected

## ◆ m_fullLayoutTime

wxLongLong wxRichTextCtrl::m_fullLayoutTime
| protected

## ◆ m_lastWindowSize

wxSize wxRichTextCtrl::m_lastWindowSize
| protected

Variables for scrollbar hysteresis detection.

## ◆ m_scale

double wxRichTextCtrl::m_scale
| protected

An overall scale factor.

## ◆ m_selection

wxRichTextSelection wxRichTextCtrl::m_selection
| protected

Selection range in character positions. -2, -2 means no selection.

## ◆ m_selectionAnchor

long wxRichTextCtrl::m_selectionAnchor
| protected

Anchor so we know how to extend the selection It's a caret position since it's between two characters.

## ◆ m_selectionAnchorObject

wxRichTextObject* wxRichTextCtrl::m_selectionAnchorObject
| protected

Anchor object if selecting multiple container objects, such as grid cells.

## ◆ m_selectionState

wxRichTextCtrlSelectionState wxRichTextCtrl::m_selectionState
| protected

## ◆ m_setupScrollbarsCount

int wxRichTextCtrl::m_setupScrollbarsCount
| protected

## ◆ m_setupScrollbarsCountInOnSize

int wxRichTextCtrl::m_setupScrollbarsCountInOnSize
| protected

## ◆ m_textCursor

wxCursor wxRichTextCtrl::m_textCursor
| protected

Cursors.

## ◆ m_urlCursor

wxCursor wxRichTextCtrl::m_urlCursor
| protected

## ◆ sm_availableFontNames

wxArrayString wxRichTextCtrl::sm_availableFontNames
| staticprotected